//*****************************************************************************
//
// File Name	: 'Main.c'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 24-12-2016, 15:00
// Revised		: 11-05-2017, 10:22
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//

//*****************************************************************************
// https://gputils.sourceforge.io/html-help/PIC18F8720-conf.html
/** C O N F I G U R A T I O N   B I T S ************  config bits is 0x 21BA  ******************/
// PIC18F8720 Configuration Bit Settings

// 'C' source line config statements

// CONFIG1H
#pragma config OSC = ECIO       // Oscillator Selection bits (EC oscillator w/ OSC2 configured as RA6)
#pragma config OSCS = OFF       // Oscillator System Clock Switch Enable bit (Oscillator system clock switch option is disabled (main oscillator is source))

// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = OFF        // Brown-out Reset Enable bit (Brown-out Reset disabled)
#pragma config BORV = 27        // Brown-out Reset Voltage bits (VBOR set to 2.7V)

// CONFIG2H
#pragma config WDT = ON        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 128      // Watchdog Timer Postscale Select bits (1:128)

// CONFIG3L
#pragma config MODE = MC        // Processor Mode Select bits (Microcontroller mode)
#pragma config WAIT = OFF       // External Bus Data Wait Enable bit (Wait selections unavailable for table reads and table writes)

// CONFIG3H
#pragma config CCP2MUX = OFF    // CCP2 Mux bit (CCP2 is multiplexed with RB3 in Extended Microcontroller, Microprocessor or Microprocessor with Boot Block mode. Or with RE7 in Microcontroller mode.)

// CONFIG4L
#pragma config STVR = OFF       // Stack Full/Underflow Reset Enable bit (Stack full/underflow will not cause Reset)
#pragma config LVP = OFF        // Low-Voltage ICSP Enable bit (Low-voltage ICSP disabled)
#pragma config DEBUG = OFF       //DEBUG: Background Debugger Enable bit
                                    //1 = Background debugger disabled. RB6 and RB7 configured as general purpose I/O pins.
                                    //0 = Background debugger enabled. RB6 and RB7 are dedicated to In-Circuit Debug.


// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000200-003FFFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (004000-007FFFh) not code-protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (008000-00BFFFh) not code-protected)
#pragma config CP3 = OFF        // Code Protection bit (Block 3 (00C000-00FFFFh) not code-protected)
#pragma config CP4 = OFF        // Code Protection bit (Block 4 (010000-013FFFh) not code-protected)
#pragma config CP5 = OFF        // Code Protection bit (Block 5 (014000-017FFFh) not code-protected)
#pragma config CP6 = OFF        // Code Protection bit (Block 6 (018000-01BFFFh) not code-protected)
#pragma config CP7 = OFF        // Code Protection bit (Block 7 (01C000-01FFFFh) not code-protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000200-003FFFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (004000-007FFFh) not write-protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (008000-00BFFFh) not write-protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (00C000-00FFFFh) not write-protected)
#pragma config WRT4 = OFF       // Write Protection bit (Block 4 (010000-013FFFh) not write-protected)
#pragma config WRT5 = OFF       // Write Protection bit (Block 5 (014000-017FFFh) not write-protected)
#pragma config WRT6 = OFF       // Write Protection bit (Block 6 (018000-01BFFFh) not write-protected)
#pragma config WRT7 = OFF       // Write Protection bit (Block 7 (01C000-01FFFFh) not write-protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000200-003FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (004000-007FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (008000-00BFFFh) not protected from table reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (00C000-00FFFFh) not protected from table reads executed in other blocks)
#pragma config EBTR4 = OFF      // Table Read Protection bit (Block 4 (010000-013FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR5 = OFF      // Table Read Protection bit (Block 5 (014000-017FFFh) not protected from table reads executed in other blocks)
#pragma config EBTR6 = OFF      // Table Read Protection bit (Block 6 (018000-01BFFFh) not protected from table reads executed in other blocks)
#pragma config EBTR7 = OFF      // Table Read Protection bit (Block 7 (01C000-01FFFFh) not protected from table reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from table reads executed in other blocks)

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

//#pragma config SOSCSEL = DIG

#include <xc.h>
// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.
//***************************************************************************** 

/*
 * Excellent CRC code.

// Update the CRC for transmitted and received data using
// the CCITT 16bit algorithm (X^16 + X^12 + X^5 + 1).
unsigned char ser_data;
static unsigned int crc;
crc = (unsigned char)(crc >> 8) | (crc << 8); 
crc ^= ser_data;
crc ^= (unsigned char)(crc & 0xff) >> 4;
crc ^= (crc << 8) << 4;
crc ^= ((crc & 0xff) << 4) << 1;
 * 
 * */
//*****************************************************************************
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h> //uint8_t, uint16_t, uint32_t

#include "Main.h"
#include "hsv.h"
#include "display.h"
#include "keyboard.h"
#include "rtc.h"
#include "ledI2C.h"
#include <time.h>
#include "i2c.h"
#include "eeprom.h"

#ifdef __PIC18F8720A__
    #include <pic18f8720.h>
    #warning including .....  ->> PIC18F8720A//upozorneni na include soubor....Je hlano pri compilaci
#endif
//*****************************************************************************

void main(){
    TTL_GLOW_off();//vypnuti zhaveni
    _init_display();//init porty displaye
    ClrWdt ();
    ReadEEprom();//nacte hodnoty pro podsvetleni 
    InitMasterPort(_HW);//init i2c HW
    InitMasterPort(_SW);//init i2c resenou pouze sw
    InitIO_PCA9633_HW(adress_LED_IC3);// init IO3 pro LED3
    srand (TMR0);    //Spusteni casovace pro generovani nahodnych cisel...
    InitIO_PCA9633_HW(adress_LED_IC4);
    InitIO_PCA9633_HW(adress_LED_IC5);
    InitIO_PCA9633_HW(adress_LED_IC2);    
    InitIO_PCA9633_SW(adress_LED_IC6);
    InitIO_PCA9633_SW(adress_LED_IC7);
    _dtLeft_UP(_CLEAR);//priznak _SET je nastaveni a priznak _CLEAR je nulovani, LEDka jako dvojtecka, LEVA HORNI
    _dtLeft_DOWN(_CLEAR);
    _dtRight_UP(_CLEAR);
    _dtRight_DOWN(_CLEAR);
    SetLightHua();// Nastaveni podsvetleni
    init_RTC(); //init rtc obvodu
    init_keyboard_PCA955PW();//nastavceni IO po i2c obvod klavesnice
    _initInterrupt();//nastavi HW preruseni na klavesnici, Obvod klavesnice generuje preruseni pro MCU a ten potom obslouzi klavesnici. Preruseni se generuje jen pro zmene na vstupu IO PCA955PW
    
    __delay_ms(100);
    PrintPomlcka(_ALL); //Zobrazi pomlcny
    ClrWdt ();
    __delay_ms(500);
    ClrWdt ();
    _dtLeft_UP(_SET);
    _dtLeft_DOWN(_SET);
    _dtRight_UP(_SET);
    _dtRight_DOWN(_SET);
    
    for(;;) {//nekonecna smycka, klavesnice je obsluhovana pres preruseni
        ClrWdt ();
        ReadRTC();//Periodicke vycitani vsech hodnot z RTC chipu
        _hour_raw (decode_segment(_DateTimeDS3231.Hour_10),decode_segment(_DateTimeDS3231.Hour));//zobrazeni dat na segmentu hodin
        _minut_raw (decode_segment(_DateTimeDS3231.Minutes_10),decode_segment(_DateTimeDS3231.Minutes));//zobrazeni dat na segmentu minut
        _second_raw (decode_segment(_DateTimeDS3231.Seconds_10),decode_segment(_DateTimeDS3231.Seconds));//zobrazeni dat na segmentu sekund
        Menu_Keyboard();  //Menu, zde se vyhodnocuje stisk tlacitek a podle toho se reaguje...        
    }
}
//*****************************************************************************
// Secondary Data Type with eeprom qualifier 

/*
__EEPROM_DATA (0x6d, 0xff, 0xff, 0x6d, 0xff, 0xff, 255, 255);//sem se uklada nastaveni podsvetleni, LED2, LED3, dva bajty je rezerva
__EEPROM_DATA (0x6d, 0xff, 0xff, 0x6d, 0xff, 0xff, 255, 255);//LED4, LED5, dva bajty rezerva
__EEPROM_DATA (0x6d, 0xff, 0xff, 0x6d, 0xff, 0xff, 255, 255);//LED 6, LED7, dva bajty rezerva
__EEPROM_DATA (0x71, 0x72, 0x73, 0x74, 0xff, 0xff, 255, 255); //rezerva
__EEPROM_DATA ("V", "e", "r", "s", "i", "o", "n", ":");//nasledujici data jsou jen informativni o puvodu a datumu fw, vcetne verze
__EEPROM_DATA ("1", ".", "2", "1", 10, 13, "D", "a");
__EEPROM_DATA ("t", "e", ":", "2", "0", ".", "1", "0");
__EEPROM_DATA (".", "2", "0", "1", "7", 10, 13, "E");
__EEPROM_DATA ("m", "a", "i", "l", ":", 20, "h", "a");
__EEPROM_DATA ("c", "e", "s", "o", "f", "t", "@", "m");
__EEPROM_DATA ("u", "j", "m", "a", "i", "l", ".", "c");
__EEPROM_DATA ("z", 10, 13, "w", "e", "b", ":","w");
__EEPROM_DATA ("w", "w", ".", "p", "r", "o", "c", "h");
__EEPROM_DATA ("a", "z", "k", "a", ".", "z", "d", "e");
__EEPROM_DATA (".", "c" , "z" ,10, 13, 0, 0, 0);
*/

 

