//*****************************************************************************
//
// File Name	: 'display.c'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 05-05-2017, 15:03
// Revised		: 12-05-2017, 15:03
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************

#include "display.h"
#include <xc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h> //uint8_t, uint16_t, uint32_t
#include "i2c.h"


void _init_display (void){
    TTL_GLOW_Init();
    TTL_HourHi_Init();
    TTL_HourLo_Init();
    TTL_MinitHi_Init();
    TTL_MinitLo_Init();
    TTL_SecondHi_Init();
    TTL_SecondLo_Init();
    TTL_GLOW_on();
    _set_12_00_00();
}
//*****************************************************************************
void _set_12_00_00(void){
    SegmentHour (12);
    SegmentMinut (0);
    SegmentSecond (0);
    
}
//*****************************************************************************
/*void _set_00_00_00(void){
    SegmentHour (0);
    SegmentMinut (0);
    SegmentSecond (0);
    
}*/
//*****************************************************************************
void setRGB_PCA9633_HW_DT (uint8_t IO_adress, uint8_t value){
    I2C_Start(_HW);
    I2C_Write(_HW,IO_adress);  //write slave address ALL
    I2C_Write(_HW,0b00000010); //pocatecni adresa PWM registru je PWM0
    I2C_Write(_HW,value);
    I2C_Stop(_HW);
}
//*****************************************************************************
void setRGB_PCA9633_SW_DT (uint8_t IO_adress, uint8_t value){
    I2C_Start(_SW);
    I2C_Write(_SW,IO_adress);  //write slave address ALL
    I2C_Write(_SW,0b00000010); //pocatecni adresa PWM registru je PWM1
    I2C_Write(_SW,value);
    I2C_Stop(_SW); 
}

//*****************************************************************************
void _dtLeft_UP (uint8_t _status){
    if (_status == _SET){
        setRGB_PCA9633_HW_DT (adress_LED_IC4, 255);
    }
    else{
        setRGB_PCA9633_HW_DT (adress_LED_IC4, 0);
    }
}
//*****************************************************************************
void _dtLeft_DOWN (uint8_t _status){
    if (_status == _SET){
        setRGB_PCA9633_HW_DT (adress_LED_IC3, 255);
    }
    else{
        setRGB_PCA9633_HW_DT (adress_LED_IC3, 0);
    }    
}
//*****************************************************************************
void _dtRight_UP (uint8_t _status){
    if (_status == _SET){
        setRGB_PCA9633_SW_DT (adress_LED_IC6, 255);
    }
    else{
        setRGB_PCA9633_SW_DT (adress_LED_IC6, 0);
    }    
}
//*****************************************************************************
void _dtRight_DOWN (uint8_t _status){
    if (_status == _SET){
        setRGB_PCA9633_HW_DT (adress_LED_IC5, 255);
    }
    else{
        setRGB_PCA9633_HW_DT (adress_LED_IC5, 0);
    }    
}
//*****************************************************************************
void TTL_GLOW_Init (void){
    TTL_GLOW_PORT = 0;
    TTL_GLOW_LAT = 0;
    TTL_GLOW_ADCON1 = 0x0F;
    tTTL_GLOW = Output;
/*
    CLRF PORTA ; Initialize PORTA by
                                    ; clearing output
                                    ; data latches
    CLRF LATA ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0x0F ; Configure A/D
    MOVWF ADCON1 ; for digital inputs
    MOVLW 0xCF ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISA ; Set RA<3:0> as inputs
                                    ; RA<5:4> as outputs
 */
    //BitClear (T0CON,T0CS);
    //BitClear (T0CON,TMR0ON);
    //BitSet (T0CON,T0SE);
 /*           
    bit 5 T0CS: Timer0 Clock Source Select bit
    1 = Transition on T0CKI pin
    0 = Internal instruction cycle clock (CLKO)  
 */
}
//*****************************************************************************
void TTL_HourHi_Init (void){//HourHi
    TTL_HourHi_PORT = 0;
    TTL_HourHi_LAT = 0;
    tTTL_HourHi = Output;
/*
    CLRF PORTD ; Initialize PORTD by
                                    ; clearing output
                                    ; data latches
    CLRF LATD ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0xCF ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISD ; Set RD<3:0> as inputs
                                    ; RD<5:4> as outputs

 */
}
//*****************************************************************************
void TTL_HourLo_Init (void){//HourLo
    TTL_HourLo_PORT = 0;
    TTL_HourLo_LAT = 0;
    tTTL_HourLo = Output;
/*
    CLRF PORTE ; Initialize PORTE by
                                    ; clearing output
                                    ; data latches
    CLRF LATE ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0x03 ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISE ; Set RE1:RE0 as inputs
                                    ; RE7:RE2 as outputs
 */
}
//*****************************************************************************
void TTL_MinitHi_Init (void){//MinitHi
    TTL_MinitHi_PORT = 0;
    TTL_MinitHi_LAT = 0;
    TTL_MinitHi_ADCON1 = 0x0F;
    tTTL_MinitHi = Output;
/*
    CLRF PORTH ; Initialize PORTH by
                                    ; clearing output
                                    ; data latches
    CLRF LATH ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0Fh ;
    MOVWF ADCON1 ;
    MOVLW 0CFh ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISH ; Set RH3:RH0 as inputs
                                    ; RH5:RH4 as outputs
                                    ; RH7:RH6 as inputs
 */
}
//*****************************************************************************
void TTL_MinitLo_Init (void){//MinitLo
    TTL_MinitLo_PORT = 0;
    TTL_MinitLo_LAT = 0;
    tTTL_MinitLo = Output;
/*
    CLRF PORTJ ; Initialize PORTG by
                                    ; clearing output
                                    ; data latches
    CLRF LATJ ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0xCF ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISJ ; Set RJ3:RJ0 as inputs
                                    ; RJ5:RJ4 as output
                                    ; RJ7:RJ6 as inputs
 */
}
//*****************************************************************************
void TTL_SecondHi_Init (void){//SecondHi
    TTL_SecondHi_PORT = 0;
    TTL_SecondHi_LAT = 0;
    TTL_SecondHi_ADCON1 = 0x0F;
    TTL_SecondHi_CMCON = 0x7;
    tTTL_SecondHi = Output;
/*
    CLRF PORTF ; Initialize PORTF by
                                    ; clearing output
                                    ; data latches
    CLRF LATF ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0x07 ;
    MOVWF CMCON ; Turn off comparators
    MOVLW 0x0F ;
    MOVWF ADCON1 ; Set PORTF as digital I/O
    MOVLW 0xCF ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISF ; Set RF3:RF0 as inputs
                                    ; RF5:RF4 as outputs
 */
}
//*****************************************************************************
void TTL_SecondLo_Init (void){//SecondLo
    TTL_SecondLoG_PORT = 0;
    TTL_SecondLoG_LAT = 0;
    tTTL_SecondLoG = Output;
/*
    CLRF PORTG ; Initialize PORTG by
                                    ; clearing output
                                    ; data latches
    CLRF LATG ; Alternate method
                                    ; to clear output
                                    ; data latches
    MOVLW 0x04 ; Value used to
                                    ; initialize data
                                    ; direction
    MOVWF TRISG ; Set RG1:RG0 as outputs
                                    ; RG2 as input
                                    ; RG4:RG3 as inputs
 */
        //bit 3-0 CCPxM3:CCPxM0: CCP Module x Mode Select bits
        //0000 = Capture/Compare/PWM disabled (resets CCPx module)

        //ECCP1M<3:0>: ECCP1 Mode Select bits
            //0000 = Capture/Compare/PWM off (resets ECCP module)
    //ECCP1CON = 0;
        //bit 2 CCP1IE: CCP1 Interrupt Enable bit
            //1 = Enables the CCP1 interrupt
            //0 = Disables the CCP1 interrupt
    //BitClear(PIE1,CCP1IE);
    //PIE1 = 0;
        //bit 1 TMR1CS: Timer1 Clock Source Select bit
            //1 = External clock from pin RC0/T1OSO/T13CKI (on the rising edge)
            //0 = Internal clock (FOSC/4)  
//    BitClear(T1CON,TMR1CS);
        //bit 0 TMR1ON: Timer1 On bit
            //1 = Enables Timer1
            //0 = Stops Timer1
    //BitClear(T1CON,TMR1ON);
        //bit 2 T1SYNC: Timer1 External Clock Input Synchronization Select bit
            //When TMR1CS = 1:
            //1 = Do not synchronize external clock input
            //0 = Synchronize external clock input
            //When TMR1CS = 0:
            //This bit is ignored. Timer1 uses the internal clock when TMR1CS = 0.
    //BitSet(T1CON, TMT1SYNC);
        //bit 3 T1OSCEN: Timer1 Oscillator Enable bit
            //1 = Timer1 oscillator is enabled
            //0 = Timer1 oscillator is shut off
            //The oscillator inverter and feedback resistor are turned off to eliminate power drain.
    //BitClear(T1CON,T1OSCEN);
  
    //---------------------
        //bit 2 T3SYNC: Timer3 External Clock Input Synchronization Control bit
            //(Not usable if the system clock comes from Timer1/Timer3.)
            //When TMR3CS = 1:
            //1 = Do not synchronize external clock input
            //0 = Synchronize external clock input
            //When TMR3CS = 0:
            //This bit is ignored. Timer3 uses the internal clock when TMR3CS = 0.
 //   BitSet(T3CON, T3SYNC);
       // bit 1 TMR3CS: Timer3 Clock Source Select bit
            //1 = External clock input from Timer1 oscillator or T13CKI (on the rising edge after the
            //first falling edge)
            //0 = Internal clock (FOSC/4)
    //BitClear(T3CON,TMR3CS);
       // bit 0 TMR3ON: Timer3 On bit
            //1 = Enables Timer3
    //BitClear(T3CON,TMR3ON);
    //BitClear (TTL_SecondLoC_PORT,TTL_Segment_SLF);
    //BitClear (TTL_SecondLoC_PORT,TTL_Segment_SLG);
    //BitClear (TTL_SecondLoC_PORT,TTL_Segment_SLT);
    BitClear (TTL_SecondLoC_LAT,TTL_Segment_SLF);
    BitClear (TTL_SecondLoC_LAT,TTL_Segment_SLG);
    BitClear (TTL_SecondLoC_LAT,TTL_Segment_SLT);
    tTTL_SecondSLF = Output;             
    tTTL_SecondSLG = Output;             
    tTTL_SecondSLT = Output;  
/*
    CLRF PORTC ; Initialize PORTC by
                                    ; clearing output
                                    ; data latches
   CLRF LATC ; Alternate method
                                    ; to clear output
                                    ; data latches
   MOVLW 0xCF ; Value used to
                                    ; initialize data
                                    ; direction
   MOVWF TRISC ; Set RC<3:0> as inputs
                                    ; RC<5:4> as outputs
                                    ; RC<7:6> as inputs
 */
}
//*****************************************************************************

void TTL_GLOW_on (void){// zapne zhaveni itronu
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_HH);
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_HL);
    
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_MH);
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_ML);
    
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_SH);
    BitSet(TTL_GLOW_LAT, _TTL_GLOW_SL);  
}
//*****************************************************************************
void TTL_GLOW_off (void){// vypne zhaveni itronu
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_HH);
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_HL);
    
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_MH);
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_ML);
    
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_SH);
    BitClear(TTL_GLOW_LAT, _TTL_GLOW_SL);  
}
//*****************************************************************************
void SegmentHour (uint8_t nHour){
    uint8_t nBufferD = 0;
    uint8_t nBufferJ = 0;
    if (nHour != 0){
        if (nHour > 9){
            nBufferD = RadDesitky (nHour);
        }
        nBufferJ = RadJednotky (nHour, nBufferD);
    }
    //if (nBufferD == 0){nBufferD = 15;}//prazdny znak
    //_hour_raw (decode_segment(1), decode_segment(2));
    _hour_raw (decode_segment(nBufferD), decode_segment(nBufferJ));
}
//*****************************************************************************
void ShowErr (void){
    _hour_raw (decode_segment(14),decode_segment(22));//show empty char
    _minut_raw (decode_segment(22),decode_segment(21));//show empty char
    _second_raw (decode_segment(21),decode_segment(21));//show empty char
}
//*****************************************************************************
void ClearDisplay (void){
    _hour_raw (decode_segment(21),decode_segment(21));//show empty char
    _minut_raw (decode_segment(21),decode_segment(21));//show empty char
    _second_raw (decode_segment(21),decode_segment(21));//show empty char
}
//*****************************************************************************
void SegmentMinut (uint8_t nMinut){
    uint8_t nBufferD = 0;
    uint8_t nBufferJ = 0;
    if (nMinut != 0){
        if (nMinut > 9){
            nBufferD = RadDesitky (nMinut);
        }
        nBufferJ = RadJednotky (nMinut, nBufferD);
    }
    _minut_raw (decode_segment(nBufferD), decode_segment(nBufferJ));
}
//*****************************************************************************
void SegmentSecond (uint8_t nSecond){
    uint8_t nBufferD = 0;
    uint8_t nBufferJ = 0;
        if (nSecond != 0){
        if (nSecond > 9){
            nBufferD = RadDesitky (nSecond);
        }
        nBufferJ = RadJednotky (nSecond, nBufferD);
    }
    _second_raw (decode_segment(nBufferD), decode_segment(nBufferJ));
}
//*****************************************************************************
unsigned char RadJednotky (uint8_t nBuffer, uint8_t nRadDesitky){
   uint8_t jednotky = 0;
   jednotky = nBuffer - (unsigned)(nRadDesitky * 10);
   return jednotky;
}
//*****************************************************************************
unsigned char RadDesitky (uint8_t nBuffer){
    uint8_t desitky = 0;
    desitky = (unsigned) nBuffer/10;
    return desitky;
}
//*****************************************************************************
void PrintHex (uint8_t nSegment, unsigned int nHex){
    unsigned int nLo;
    unsigned int nHi;
    
    //nLo = 0;
    //nHi = 0;
    nLo = (nHex and 0b00001111);
    nHi = (nHex and 0b11110000) ror 4;
    if (nSegment == 1){
        _hour_raw (decode_segment(nHi),decode_segment(nLo));
    }
    if (nSegment == 2){
        _minut_raw (decode_segment(nHi),decode_segment(nLo));
    }
    if (nSegment == 3){
        _second_raw (decode_segment(nHi),decode_segment(nLo));
    }
}
//*****************************************************************************
void PrintPomlcka (uint8_t nSegment){
    if (nSegment == 1){
        _hour_raw (decode_segment(16),decode_segment(16));
    }
    if (nSegment == 2){
        _minut_raw (decode_segment(16),decode_segment(16));
    }
    if (nSegment == 3){
        _second_raw (decode_segment(16),decode_segment(16));
    }
    if (nSegment == _ALL){
        _second_raw (decode_segment(16),decode_segment(16));
        _minut_raw  (decode_segment(16),decode_segment(16));
        _hour_raw   (decode_segment(16),decode_segment(16));
    }
}
//*****************************************************************************
void PrintSpace (uint8_t nSegment){
    if (nSegment == 1){
        _hour_raw (decode_segment(17),decode_segment(17));
    }
    if (nSegment == 2){
        _minut_raw (decode_segment(17),decode_segment(17));
    }
    if (nSegment == 3){
        _second_raw (decode_segment(17),decode_segment(17));
    }
}
//*****************************************************************************
uint8_t decode_segment (uint8_t nSegment){//dekuduje desitkove cislo na segmetny zobrazovace
    uint8_t nBuffer = 0;
    switch ( nSegment ) {
        case 0: //znak 0          
            nBuffer = 0b01111011;
        break;
        case 1: //znak 1          
            nBuffer = 0b01000001;
        break;
        case 2: //znak 2         
            nBuffer = 0b00110111;
        break;
        case 3: //znak 3           
            nBuffer = 0b01100111;
        break;
        case 4: //znak 4            
            nBuffer = 0b01001101;
        break;
        case 5: //znak 5            
            nBuffer = 0b01101110;
        break;
        case 6: //znak 6            
            nBuffer = 0b01111110;
        break;
        case 7: //znak 7            
            nBuffer = 0b01000011;
        break;
        case 8: //znak 8           
            nBuffer = 0b01111111;
        break;
        case 9: //znak 9            
            nBuffer = 0b01101111;
        break;
        case 10: //znak A            
            nBuffer = 0b01011111;
        break;
        case 11: //znak B            
            nBuffer = 0b01111100;
        break;
        case 12: //znak C            
            nBuffer = 0b00111010;
        break;
        case 13: //znak D            
            nBuffer = 0b01110101;
        break;
        case 14: //znak E            
            nBuffer = 0b00111110;
        break;
        case 15: //znak F            
            nBuffer = 0b00011110;
        break;
        case 16: //zobrazi minus          
            nBuffer = 0b00000100;
        break;
        case 17: //zobrazi znas u ---space         
            nBuffer = 0b01110000;
        break;
        case 20: //znak DT  (desetina tecka)          
            nBuffer = 0b10000000;
        break;
        case 21: //zobrazi prazdny znak            
            nBuffer = 0b00000000;
        break;
        case 22: //znad r            
            nBuffer = 0b00010100;
        break;
    default:      //zobrazi prazdny znak      
        nBuffer = 0b10000001;
    break;
  }   
    return nBuffer;
}
//*****************************************************************************
void _hour_raw (uint8_t dRaw_hi, uint8_t dRaw_lo){//zobrazi data na segmentovek hodiny
    //_Hour_port_hi =  dRaw_hi;
    //_Hour_port_lo =  dRaw_lo;
    TTL_HourHi_LAT = dRaw_hi;
    TTL_HourLo_LAT = dRaw_lo;
}
//*****************************************************************************
void _minut_raw (uint8_t dRaw_hi, uint8_t dRaw_lo){//zobrazi data na segmentovek minuty
    //_Minut_port_hi =  dRaw_hi;
   // _Minut_port_lo =  dRaw_lo;
    TTL_MinitHi_LAT = dRaw_hi;
    TTL_MinitLo_LAT = dRaw_lo;
}
//*****************************************************************************
void _second_raw (uint8_t dRaw_hi, uint8_t dRaw_lo){//zobrazi data na segmentovek sekundy
   // _Second_port_hi = dRaw_hi;
  //  _Second_port_loh =  dRaw_lo;
    TTL_SecondHi_LAT = dRaw_hi;
    TTL_SecondLoG_LAT = dRaw_lo;
    if (BTFSC ( dRaw_lo, BIT_5)) 
        {BitSet(TTL_SecondLoC_LAT,  _Second_lo_F);}
    else{BitClear(TTL_SecondLoC_LAT, _Second_lo_F);}
 
    if (BTFSC ( dRaw_lo, BIT_6))
        {BitSet(TTL_SecondLoC_LAT, _Second_lo_G);}
    else{BitClear(TTL_SecondLoC_LAT, _Second_lo_G);}
    
    if (BTFSC (dRaw_lo, BIT_7))
        {BitSet(TTL_SecondLoC_LAT, _Second_lo_DT);}
    else{BitClear(TTL_SecondLoC_LAT, _Second_lo_DT);}
}
//*****************************************************************************
/*void Stopky10_setiny (void){
    for(;;) {
        _set_00_00_00();
        for (uint8_t a = 0; a< 100; a++){
            for (uint8_t b = 0; b< 100; b++){
                for (uint8_t c = 0; c< 100; c++){
                    SegmentSecond (c);
                    __delay_ms(17);
                }
                SegmentMinut (b);
            }
            SegmentHour (a);
        }  
    }
}*/
//*****************************************************************************
/*void Stopky60_setiny (void){
    for(;;) {
        _set_00_00_00();
        for (uint8_t a = 0; a< 60; a++){
            for (uint8_t b = 0; b< 60; b++){
                for (uint8_t c = 0; c< 60; c++){
                    SegmentSecond (c);
                    __delay_ms(17);
                }
                SegmentMinut (b);
            }
            SegmentHour (a);
        } 
    }
}*/
//*****************************************************************************
/*void Stopky60_sekundy (void){
    for(;;) {
        _set_00_00_00();
        for (uint8_t a = 0; a< 24; a++){
            for (uint8_t b = 0; b< 60; b++){
                for (uint8_t c = 0; c< 60; c++){
                    SegmentSecond (c);
                    __delay_ms(700);
                }
                SegmentMinut (b);
            }
            SegmentHour (a);
        } 
    }
}
*/