//*****************************************************************************
//
// File Name	: 'display.h'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 05-05-2017, 15:04
// Revised		: 05-05-2017, 15:04
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <stdint.h> //uint8_t, uint16_t, uint32_t
#include <xc.h> // include processor files - each processor file is guarded.  

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

#ifndef display_LIB
#define display_LIB

#define _XTAL_FREQ 20000000  // 20 MHz OSC
#define Output 0
#define Input 1
//*****************************************************************************
//
//                  B
//                -----
//              D | C | A
//                -----
//              E |   | G
//                -----      .
//                  F       DT
//  Segment Hour Hi
#define _Hour_hi_A                  PORTDbits.RD0
#define _Hour_hi_B                  PORTDbits.RD1
#define _Hour_hi_C                  PORTDbits.RD2
#define _Hour_hi_D                  PORTDbits.RD3
#define _Hour_hi_E                  PORTDbits.RD4
#define _Hour_hi_F                  PORTDbits.RD5
#define _Hour_hi_G                  PORTDbits.RD6
#define _Hour_hi_DT                 PORTDbits.RD7
#define _Hour_port_hi               PORTD
#define tHour_hi                    TRISD
#define TTL_Hour_hiD_LAT            LATD
#define TTL_Segment_DT_D            7

//  Segment Hour Lo
#define _Hour_lo_A                  PORTEbits.RE0
#define _Hour_lo_B                  PORTEbits.RE1
#define _Hour_lo_C                  PORTEbits.RE2
#define _Hour_lo_D                  PORTEbits.RE3
#define _Hour_lo_E                  PORTEbits.RE4
#define _Hour_lo_F                  PORTEbits.RE5
#define _Hour_lo_G                  PORTEbits.RE6
#define _Hour_lo_DT                 PORTEbits.RE7
#define _Hour_port_lo               PORTE
#define tHour_lo                    TRISE
#define TTL_Hour_loE_LAT            LATE
#define TTL_Segment_DT_E            TTL_Segment_DT_D

//  Segment Minut Hi
#define _Minut_hi_A                 PORTHbits.RH0
#define _Minut_hi_B                 PORTHbits.RH1
#define _Minut_hi_C                 PORTHbits.RH2
#define _Minut_hi_D                 PORTHbits.RH3
#define _Minut_hi_E                 PORTHbits.RH4
#define _Minut_hi_F                 PORTHbits.RH5
#define _Minut_hi_G                 PORTHbits.RH6
#define _Minut_hi_DT                PORTHbits.RH7
#define _Minut_port_hi              PORTH
#define tMinut_hi                   TRISH
#define TTL_Minut_hiH_LAT           LATH
#define TTL_Segment_DT_H            TTL_Segment_DT_D

//  Segment Minut Lo
#define _Minut_lo_A                 PORTJbits.RJ0
#define _Minut_lo_B                 PORTJbits.RJ1
#define _Minut_lo_C                 PORTJbits.RJ2
#define _Minut_lo_D                 PORTJbits.RJ3
#define _Minut_lo_E                 PORTJbits.RJ4
#define _Minut_lo_F                 PORTJbits.RJ5
#define _Minut_lo_G                 PORTJbits.RJ6
#define _Minut_lo_DT                PORTJbits.RJ7
#define _Minut_port_lo              PORTJ
#define tMinut_lo                   TRISJ
#define TTL_Minut_loJ_LAT           LATJ
#define TTL_Segment_DT_J            TTL_Segment_DT_D

//  Segment Second Hi
#define _Second_hi_A                PORTFbits.RF0
#define _Second_hi_B                PORTFbits.RF1
#define _Second_hi_C                PORTFbits.RF2
#define _Second_hi_D                PORTFbits.RF3
#define _Second_hi_E                PORTFbits.RF4
#define _Second_hi_F                PORTFbits.RF5
#define _Second_hi_G                PORTFbits.RF6
#define _Second_hi_DT               PORTFbits.RF7
#define _Second_port_hi             PORTF
#define tSecond_hi                  TRISF
#define TTL_Second_hiF_LAT          LATF
#define TTL_Segment_DT_F            TTL_Segment_DT_D

//  Segment Second Lo
#define _Second_lo_A                PORTGbits.RG0
#define _Second_lo_B                PORTGbits.RG1
#define _Second_lo_C                PORTGbits.RG2
#define _Second_lo_D                PORTGbits.RG3
#define _Second_lo_E                PORTGbits.RG4
#define _Second_lo_F                0 //PORTCbits.RC0
#define _Second_lo_G                1 //PORTCbits.RC1
#define _Second_lo_DT               2 //PORTCbits.RC2
#define tSecond_lo                  TRISG
#define tSecond_lo_F                TRISCbits.TRISC0
#define tSecond_lo_G                TRISCbits.TRISC1
#define tSecond_lo_DT               TRISCbits.TRISC2
#define _Second_port_loh            PORTG
#define _Second_port_lol            PORTC
#define TTL_Segment_DT_C            _Second_lo_DT


// zhaveni-GLOW
#define _TTL_GLOW_HH                0 //RA0 // Hour Hi
#define _TTL_GLOW_HL                1 //RA1 // Hour Li

#define _TTL_GLOW_MH                2 //RA2 // Minut Hi
#define _TTL_GLOW_ML                3 //RA3 // Minut Li

#define _TTL_GLOW_SH                4 //RA4 // Second Hi
#define _TTL_GLOW_SL                5 //RA5 // Second Li
#define tTTL_GLOW                   TRISA
#define TTL_GLOW_PORT               PORTA
#define TTL_GLOW_LAT                LATA
#define TTL_GLOW_ADCON1             ADCON1
#define T0CS                        5
#define TMR0ON                      7
#define T0SE                        4
/********************************************/
#define tTTL_HourHi                 TRISD
#define TTL_HourHi_PORT             PORTD
#define TTL_HourHi_LAT              LATD
/********************************************/
#define tTTL_HourLo                 TRISE
#define TTL_HourLo_PORT             PORTE
#define TTL_HourLo_LAT              LATE
/********************************************/
#define tTTL_MinitHi                TRISH
#define TTL_MinitHi_PORT            PORTH
#define TTL_MinitHi_LAT             LATH
#define TTL_MinitHi_ADCON1          ADCON1
/********************************************/
#define tTTL_MinitLo                TRISJ
#define TTL_MinitLo_PORT            PORTJ
#define TTL_MinitLo_LAT             LATJ
/********************************************/
#define tTTL_SecondHi               TRISF
#define TTL_SecondHi_PORT           PORTF
#define TTL_SecondHi_LAT            LATF
#define TTL_SecondHi_ADCON1         ADCON1
#define TTL_SecondHi_CMCON          CMCON
/********************************************/
#define tTTL_SecondLoG              TRISG
#define TTL_SecondLoG_PORT          PORTG
#define TTL_SecondLoG_LAT           LATG
#define TTL_Segment_SLF             0
#define TTL_Segment_SLG             1
#define TTL_Segment_SLT             2
#define tTTL_SecondSLF              TRISCbits.TRISC0
#define tTTL_SecondSLG              TRISCbits.TRISC1
#define tTTL_SecondSLT              TRISCbits.TRISC2
#define tTTL_SecondLoC              TRISC
#define TTL_SecondLoC_PORT          PORTC
#define TTL_SecondLoC_LAT           LATC
#define CCP1IE                      2
#define TMR1CS                      1
#define TMR1ON                      0
#define TMT1SYNC                    2
#define T1OSCEN                     3
#define T3SYNC                      2
#define TMR3CS                      1
#define TMR3ON                      0
/********************************************/

#define BitTest(_registr, _bit)  (_registr & (0x01 << _bit))
#define BIT_0 1
#define BIT_1 2
#define BIT_2 4
#define BIT_3 8
#define BIT_4 16
#define BIT_5 32
#define BIT_6 64
#define BIT_7 128
#define and   &
#define ror   >>
#define rol   <<
#define _SET  1
#define _CLEAR  0
#define _ALL  255

#define adress_LED_IC3         0b11000100 //HW I2C
#define adress_LED_IC4         0b11000010 //HW I2C
#define adress_LED_IC5         0b11000110 //HW I2C
#define adress_LED_IC6         0b11000000 //SW I2C

#define BTFSC(_registr, _bit)  (_registr & _bit) != 0
#define BitSet(_registr, _bit)   (_registr |= (1<<_bit))		// definuje nastaven bitu
#define BitClear(_registr, _bit) (_registr &= ~(1<<_bit))       // definuje vynulovn bitu
#define BitNeg(_registr, _bit)   (_registr ^= (1<<_bit))		// definuje negovn bitu

void _init_display (void);
void _set_12_00_00(void);
void _hour_raw (uint8_t dRaw_hi, uint8_t dRaw_lo);
void _minut_raw (uint8_t dRaw_hi, uint8_t dRaw_lo);
void _second_raw (uint8_t dRaw_hi, uint8_t dRaw_lo);
uint8_t decode_segment (uint8_t nSegment);
uint8_t RadJednotky (uint8_t nBuffer, uint8_t nRadDesitky);
uint8_t RadDesitky (uint8_t nBuffer);
void SegmentHour (uint8_t nHour);
void SegmentMinut (uint8_t nMinut);
void SegmentSecond (uint8_t nSecond);
void TTL_GLOW_on (void);
void TTL_GLOW_off (void);
void TTL_GLOW_Init (void);
void TTL_HourHi_Init (void);
void TTL_HourLo_Init (void);
void TTL_MinitHi_Init (void);
void TTL_MinitLo_Init (void);
void TTL_SecondHi_Init (void);
void TTL_SecondLo_Init (void);
void Stopky10_setiny (void);
void Stopky60_setiny (void);
void Stopky60_sekundy (void);
void _set_00_00_00(void);
void PrintHex (uint8_t nSegment,unsigned int nHex);
void PrintPomlcka (uint8_t nSegment);
void PrintSpace (uint8_t nSegment);
void ClearDisplay (void);
void ShowErr (void);
void setRGB_PCA9633_HW_DT (uint8_t IO_adress, uint8_t value);
void setRGB_PCA9633_SW_DT (uint8_t IO_adress, uint8_t value);
void _dtLeft_UP (uint8_t _status);
void _dtLeft_DOWN (uint8_t _status);
void _dtRight_UP (uint8_t _status);
void _dtRight_DOWN (uint8_t _status);


#endif