//*****************************************************************************
//
// File Name	: 'i2c.h'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 30-06-2017, 11:58
// Revised		: 30-06-2017, 12:07
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************
/* Microchip Technology Inc. and its subsidiaries.  You may use this software 
 * and any derivatives exclusively with Microchip products. 
 * 
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".  NO WARRANTIES, WHETHER 
 * EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED 
 * WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A 
 * PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION 
 * WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
 * INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
 * WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS 
 * BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE 
 * FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS 
 * IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF 
 * ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 * MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE 
 * TERMS. 
 */

/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

#ifndef i2c_LIB
#define i2c_LIB

#define Output 0
#define Input 1
#define _SW 0
#define _HW 1
/* I2C clock in Hz */
//#define SCL_CLOCK  1000000L
#define SCL_CLOCK  172413L
#define _XTAL_FREQ 20000000  // 20 MHz OSC
#include <stdint.h> //uint8_t, uint16_t, uint32_t
#define _wt_speed_i2c_Master  (((_XTAL_FREQ/SCL_CLOCK)-16)/2)  /* must be > 10 for stable operation */  //T50


#define SCL_MasterSW        PORTBbits.RB0
#define SDA_MasterSW        PORTBbits.RB1
#define SCL_MasterSW_PIN    0
#define SDA_MasterSW_PIN    1
#define SCLt_MasterSW       TRISBbits.TRISB0
#define SDAt_MasterSW       TRISBbits.TRISB1

#define SCL_MasterHW        PORTCbits.RC3
#define SDA_MasterHW        PORTCbits.RC4
#define SCL_MasterHW_PIN    3
#define SDA_MasterHW_PIN    4
#define SCLt_MasterHW       TRISCbits.TRISC3
#define SDAt_MasterHW       TRISCbits.TRISC4

#define ACKNOWLEDGE             1
#define NOT_ACKNOWLEDGE         0
#define SSPIF                   3

#define BitTest(_registr, _bit)  (_registr & (0x01 << _bit))
#define BitSet(_registr, _bit)   (_registr |= (1<<_bit))		// definuje nastaven bitu
#define BitClear(_registr, _bit) (_registr &= ~(1<<_bit))	// definuje vynulovn bitu
#define BitNeg(_registr, _bit)   (_registr ^= (1<<_bit))		// definuje negovn bitu


void I2C_Start(uint8_t type);
void I2C_StartMasterSW(void);
void i2c_Start(void);
void I2C_Stop(uint8_t type);
void I2C_StopMasterSW(void);
void i2c_Stop(void);
void I2C_Write(uint8_t type, unsigned char data);
void I2C_WriteMasterSW(unsigned char data);
void i2c_Write(unsigned char data);
void i2c_Address(unsigned char address, unsigned char mode);
unsigned char I2C_Read(uint8_t type, unsigned char ack);
unsigned char I2C_ReadMasterSW(void);
unsigned char i2c_Read(unsigned char ack);
void i2c_Ack_HW(unsigned char ack);
void I2C_AckNowLedgeMasterSW(void);
void I2C_ReStart(uint8_t type);
void I2C_ReStartMasterSW (void);
void i2c_Restart(void);
void I2C_HW_Wait(void);
void I2C_ClockMasterSW(void);
void InitMasterPort(uint8_t type);
void InitMasterSwPort(void);
void InitMasterHwPort(void);
void i2c_WaitGeneral(void);

void I2C_Start_PCA955PW(void);
void I2C_Write_PCA955PW(unsigned char data);
void I2C_ReStart_PCA955PW(void);
unsigned char I2C_Read_PCA955PW(unsigned char ack);
void I2C_Stop_PCA955PW(void);
void i2c_WaitGeneral_PCA955PW(void);
void I2C_HW_Wait_PCA955PW(void);




#endif

