//*****************************************************************************
//
// File Name	: 'keyboard.c'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 05-05-2017, 15:08
// Revised		: 05-10-2017, 14:38
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************
//*****************************************************************************
/*
  stac porovnvat aktuln stav tlactka s predchozm stavem.

A to zpravidla tak, ze si udalta dva (bitov) promenn (dva bity pro kazd tlactko) BUTTON a BTNBLOCK. 
Pokud je zjisteno stisknut tl. (kter zroven nen blokovno), nastav BUTTON i BTNBLOCK do log 1. 
BUTTON je potom flag pro program, kter res a obsluhuje tlactka. Po precten flagu jej hned nulujeme, 
zatmco BTNBLOCK (intern stavov promenn zustv v 1). BUTTON je tedy vlastne signalizace udlosti STISKU tlactka.
V prpade, ze je tlactko blokovan (BTNBLOCK==1) a je zjisteno jeho uvolnen, resetujte jako BUTTON tak BTNBLOCK.
 
if ((TLAC_STISKNUTO)&&(!BTNBLOCK)) { BUTTON=1; BTNBLOCK=1; }
if ((!TLAC_STISKNUTO)&&(BTNBLOCK)) { BUTTON=0; BTNBLOCK=0; }

 Je pom?rn? zrejm, ze pro kazd dals tlactko jsou potrebn dals dve bitov promenn a dve samostan podmnky. Tyto podmnky se pak volaj v prerusen od casovace a to 
 jednou za kazdch cca 10-20ms. Ne vc, ne mn.

V tele programu se potom pouze tzete, bylo-li stisknuto tlactk a pokud ano, pouze smazete prslusn flag. Tento obsluzn kd (ke kazdmu tlactku) se muze volat libovolnekrt za sekundu. 
 Flag BUTTON se nastav pouze jedinkrt pri STISKU tlactka. Funkce obsluhy cudlku se provede pouze JEDNOU pri stisku tlactka. 

if (BUTTON) {
  BUTTON=0;
  Proved_Obsluhu_Stisku_Cudliku();
}
 
#define TLAC_STISKNUTO ((PIND & (1 << PD2)) == 0)


KD: VYBRA? V?ETKO
volatile uint8_t BTNBLOCK=0;
volatile uint8_t BUTTON=0;


KD: VYBRA? V?ETKO
ISR(TIMER1_COMPA_vect){

if ((TLAC_STISKNUTO)&&(!BTNBLOCK)) { BUTTON=1; BTNBLOCK=1; }
if ((!TLAC_STISKNUTO)&&(BTNBLOCK)) { BUTTON=0; BTNBLOCK=0; }        
}


KD: VYBRA? V?ETKO
while(1)
if (BUTTON) {
  BUTTON=0;
nejaka akcia ;

 */

#include <xc.h>
#include "hsv.h"
#include <stddef.h> //nefinuje NULL
#include "i2c.h"
#include "rtc.h"
#include "keyboard.h"
#include "display.h"
#include "ledI2C.h"
#include "eeprom.h"

//*****************************************************************************
void init_keyboard_PCA955PW (void){
    __delay_ms(2);
    I2C_Start(_HW);
    __delay_ms(2);
    I2C_Write(_HW,adress_keyboard_write); 
    __delay_ms(2);
    I2C_Write(_HW,Polarity_Inversion_Port_0);
    __delay_ms(2);
    I2C_Write(_HW,0xff);
    __delay_ms(2);
    I2C_Write(_HW,0xff);
    __delay_ms(2);
    I2C_ReStart(_HW);
    __delay_ms(2);
    I2C_Write(_HW,adress_keyboard_write); 
    __delay_ms(2);
    I2C_Write(_HW,Configuration_Port_0);
    __delay_ms(2);
    I2C_Write(_HW,0xff);
    __delay_ms(2);
    I2C_Write(_HW,0xff);
    __delay_ms(2);
    I2C_Stop(_HW);
    __delay_ms(2);
     
   
    _StruscReadKeyboard.nOK_loop = 0;
    _StruscReadKeyboard.position_menu = 0;
    _StruscReadKeyboard.DT_blik = 1;
    _StruscReadKeyboard.DT_blik_Loop = 0;
    _StruscReadKeyboard._SpeedFlag = 0;
    _StruscReadKeyboard._SignalButtom = 0;
    _StruscReadKeyboard.position_sub_menuHLS = 0;
    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
    _StruscReadKeyboard._tagALL = _false;
}
//*****************************************************************************
void Read_keyboard_PCA955PW (void){
    GIE = 0;        // Global interrupt stopped
    __delay_ms(1);
    I2C_Start_PCA955PW();
    I2C_Write_PCA955PW(adress_keyboard_write); 
    I2C_Write_PCA955PW(Input_Port_0);
    I2C_ReStart_PCA955PW();
    I2C_Write_PCA955PW(adress_keyboard_read); 
    _StruscReadKeyboard._Input_Port_0 = I2C_Read_PCA955PW(ACKNOWLEDGE);
    _StruscReadKeyboard._Input_Port_1 = I2C_Read_PCA955PW(NOT_ACKNOWLEDGE);
    I2C_Stop_PCA955PW();
    
    GIE = 1;        // Global interrupt enable
    if ((TL_OK)&&(!_BTNBLOCKlo._bit.TL_OK_BTNBLOCK)){ _BUTTON._bit.TL_OK_BUTTON = 1; _BTNBLOCKlo._bit.TL_OK_BTNBLOCK = 1;}
   if ((!TL_OK)&&(_BTNBLOCKlo._bit.TL_OK_BTNBLOCK)){ _BUTTON._bit.TL_OK_BUTTON = 0; _BTNBLOCKlo._bit.TL_OK_BTNBLOCK = 0;}
   
   if ((TL_LEFT)&&(!_BTNBLOCKlo._bit.TL_LEFT_BTNBLOCK)){ _BUTTON._bit.TL_LEFT_BUTTON = 1; _BTNBLOCKlo._bit.TL_LEFT_BTNBLOCK = 1;}
   if ((!TL_LEFT)&&(_BTNBLOCKlo._bit.TL_LEFT_BTNBLOCK)){ _BUTTON._bit.TL_LEFT_BUTTON = 0; _BTNBLOCKlo._bit.TL_LEFT_BTNBLOCK = 0;}
   
   if ((TL_RIGHT)&&(!_BTNBLOCKlo._bit.TL_RIGHT_BTNBLOCK)){ _BUTTON._bit.TL_RIGHT_BUTTON = 1; _BTNBLOCKlo._bit.TL_RIGHT_BTNBLOCK = 1;}
   if ((!TL_RIGHT)&&(_BTNBLOCKlo._bit.TL_RIGHT_BTNBLOCK)){ _BUTTON._bit.TL_RIGHT_BUTTON = 0; _BTNBLOCKlo._bit.TL_RIGHT_BTNBLOCK = 0;}
   
   if ((TL_UP)&&(!_BTNBLOCKlo._bit.TL_UP_BTNBLOCK)){ _BUTTON._bit.TL_UP_BUTTON = 1; _BTNBLOCKlo._bit.TL_UP_BTNBLOCK = 1;}
   if ((!TL_UP)&&(_BTNBLOCKlo._bit.TL_UP_BTNBLOCK)){ _BUTTON._bit.TL_UP_BUTTON = 0; _BTNBLOCKlo._bit.TL_UP_BTNBLOCK = 0;}
   
   if ((TL_DOWN)&&(!_BTNBLOCKlo._bit.TL_DOWN_BTNBLOCK)){ _BUTTON._bit.TL_DOWN_BUTTON = 1; _BTNBLOCKlo._bit.TL_DOWN_BTNBLOCK = 1;}
   if ((!TL_DOWN)&&(_BTNBLOCKlo._bit.TL_DOWN_BTNBLOCK)){ _BUTTON._bit.TL_DOWN_BUTTON = 0; _BTNBLOCKlo._bit.TL_DOWN_BTNBLOCK = 0;}
}
//*****************************************************************************
void Menu_Keyboard (void){
    if (_BUTTON._bit.TL_DOWN_BUTTON) {//show datum
        _BUTTON._bit.TL_DOWN_BUTTON = 0;
        ShowDate();
    }
    if (_BUTTON._bit.TL_OK_BUTTON) {
        _StruscReadKeyboard.nOK_loop = _StruscReadKeyboard.nOK_loop + 1;
        if (_StruscReadKeyboard.nOK_loop == _Delka_stisku_tlacitka_DolniMer){//delka stisku 3 sec.
            _StruscReadKeyboard.nOK_loop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
            ClearDisplay();
            _dtLeft_UP(_CLEAR);
            _dtLeft_DOWN(_CLEAR);
            _dtRight_UP(_CLEAR);
            _dtRight_DOWN(_CLEAR);
            Edit();
            _dtLeft_UP(_SET);
            _dtLeft_DOWN(_SET);
            _dtRight_UP(_SET);
            _dtRight_DOWN(_SET);
        }
    }
    else {
        _StruscReadKeyboard.nOK_loop = 0;
         _BUTTON._bit.TL_OK_BUTTON = 0;}
}
//*****************************************************************************
void Edit (void){
    for(;_StruscReadKeyboard.nOK_loop == 0;){//menu
        ClrWdt ();
        __delay_ms(_menuLoop);
        if (_BUTTON._bit.TL_OK_BUTTON) {
            _StruscReadKeyboard.nOK_EndLoop = _StruscReadKeyboard.nOK_EndLoop + 1;
            if (_StruscReadKeyboard.nOK_EndLoop == 254){_StruscReadKeyboard.nOK_EndLoop = 255;}//korekce preteceni...
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                _StruscReadKeyboard.nOK_loop = 1; //ukonceni edit menu
               _BUTTON._bit.TL_OK_BUTTON = 0;
                _StruscReadKeyboard.nOK_SubMenuLoop = 0;
                _StruscReadKeyboard.nOK_EndLoop = 0;
            }
        }
        else {
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nOK_EndLoop <= (_Delka_stisku_tlacitka_HorniMer)){//potvrzeni funkce. Vnoreni do podmenu
                _StruscReadKeyboard.nOK_SubMenuLoop = 1;
            }
            _StruscReadKeyboard.nOK_EndLoop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
        }
        //*********************************************************************
        // kod editace a nastaveni hodin
        IndikaceMenu();
        switch (_StruscReadKeyboard.position_menu){
                
            case 0 ://editace casu 
                if (_StruscReadKeyboard.nOK_SubMenuLoop == 1){//editace submenu
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    Edit_Time();
                    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                }
              break;

            case 1 ://editace datumu 
                if (_StruscReadKeyboard.nOK_SubMenuLoop == 1){//editace submenu
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    Edit_Datumu();
                    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
                }
              break;
              
             case 2 ://editace podsvetleni
                 if (_StruscReadKeyboard.nOK_SubMenuLoop == 1){//editace submenu
                     _BUTTON._bit.TL_OK_BUTTON = 0;
                    Edit_Podsvetleni();
                    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
                }
              break;
              
             case 3 ://zobrazeni teploty 
                 ShowTemp();
              break;

            default ://default...asi je neco spatne 
                ShowErr();
             break;
        } 
        // kod pro posouvani v menu funkci ... doprava doleva
        
        if (_BUTTON._bit.TL_LEFT_BUTTON) {
            _BUTTON._bit.TL_LEFT_BUTTON = 0;
            _StruscReadKeyboard.position_menu = (unsigned) _StruscReadKeyboard.position_menu - 1;
            if (_StruscReadKeyboard.position_menu == 255){
                _StruscReadKeyboard.position_menu = _end_menu;
            }
        }
        
        if (_BUTTON._bit.TL_RIGHT_BUTTON) {
            _BUTTON._bit.TL_RIGHT_BUTTON = 0;
            _StruscReadKeyboard.position_menu =(unsigned) _StruscReadKeyboard.position_menu + 1;
            if (_StruscReadKeyboard.position_menu >= (_end_menu + 1)){
                _StruscReadKeyboard.position_menu = 0;
            }
        }
        
        
    }
}
//*****************************************************************************
void IndikaceMenu (void){
    //funkce indikuje editovany udaj...pomoci blikani patricne desetinne tecky
    
    _StruscReadKeyboard.DT_blik_Loop = (unsigned)_StruscReadKeyboard.DT_blik_Loop + 1;
    if (_StruscReadKeyboard.DT_blik_Loop == _change_DT_Const){//provede se zmena stavu DT
        _StruscReadKeyboard.DT_blik_Loop = 0;
        DTstatus();
    }
    ClearSetDT();//Smaze vsechny nastavene DT a opet je nastavi
    switch (_StruscReadKeyboard.position_menu){

        case 0 ://editace casu
            ClearDisplay();
            if (_StruscReadKeyboard.DT_blik == 1) {
                BitSet(TTL_Hour_hiD_LAT, TTL_Segment_DT_D);
            }
          break;

        case 1 ://editace datumu 
            ClearDisplay();
            if (_StruscReadKeyboard.DT_blik ==1) {
                BitSet(TTL_Hour_loE_LAT, TTL_Segment_DT_E);
            }
          break;

         case 2 ://editace podsvetleni
             ClearDisplay();
             if (_StruscReadKeyboard.DT_blik ==1) {
                BitSet(TTL_Minut_hiH_LAT, TTL_Segment_DT_H);
            }
          break;
              
          case 3 ://zobrazeni teploty 
             if (_StruscReadKeyboard.DT_blik ==1) {
                BitSet(TTL_Minut_loJ_LAT, TTL_Segment_DT_J);
            }
          break;

          case 4 ://reserve
              ClearDisplay();
             if (_StruscReadKeyboard.DT_blik ==1) {
                BitSet(TTL_Second_hiF_LAT, TTL_Segment_DT_F);
            }
          break;

          case 5 ://reserve
              ClearDisplay();
             if (_StruscReadKeyboard.DT_blik ==1) {
                BitSet(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
            }
          break;

        default ://default...asi je neco spatne 
            ShowErr();
         break;
    }  
}
//*****************************************************************************
void DTstatus (void){
    if (_StruscReadKeyboard.DT_blik == 0){//DT nesviti
        _StruscReadKeyboard.DT_blik = 1;
    }
    else {//DT sviti
        _StruscReadKeyboard.DT_blik = 0;
    }
}
//*****************************************************************************
void ClearSetDT (void){
    BitClear(TTL_Hour_hiD_LAT, TTL_Segment_DT_D);
    BitClear(TTL_Hour_loE_LAT, TTL_Segment_DT_E);
    
    BitClear(TTL_Minut_hiH_LAT, TTL_Segment_DT_H);
    BitClear(TTL_Minut_loJ_LAT, TTL_Segment_DT_J);
    
    BitClear(TTL_Second_hiF_LAT, TTL_Segment_DT_F);
    BitClear(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
}
//*****************************************************************************
void _initInterrupt(void){
    BitSet(tRB2_INT2, INT2);    //Nastavi RB2/INT2 jako vstupni pin
    BitClear(RB2_INT2, INT2); //vynuluje pripadnou vystupni hodnotu
    INTEDG2 = 0;
    //bit 4 INTEDG2: External Interrupt 2 Edge Select bit
        //1 = Interrupt on rising edge
        //0 = Interrupt on falling edge
    INT2IE = 1;
    //bit 4 INT2IE: INT2 External Interrupt Enable bit
    //    1 = Enables the INT2 external interrupt
    //    0 = Disables the INT2 external interrupt
    
    INT2IP = 1;
    //bit 7 INT2IP: INT2 External Interrupt Priority bit
    //    1 = High priority
    //    0 = Low priority
    
    INT2IF = 0;
    //bit 1 INT2IF: INT2 External Interrupt Flag bit
    //    1 = The INT2 external interrupt occurred (must be cleared in software)
    //    0 = The INT2 external interrupt did not occur
    GIE = 1;        // Global interrupt enable
   }
//*****************************************************************************
void interrupt tc_int (void){
    // interrupt function  
    if((INT2IF == _true) && (INT2IE == _true)){ //preruseni od INT2  
        INT2IF = 0;                             //clear INT2 interupt
        //BitSet(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
        Read_keyboard_PCA955PW();               //read keyboard
    }
}
//*****************************************************************************
void Edit_Time (void){
    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
    for(;_StruscReadKeyboard.nOK_SubMenuLoop == 0;){//SubMenu
        ClrWdt ();
        __delay_ms(_menuLoop );
        if (_BUTTON._bit.TL_OK_BUTTON) {
            _StruscReadKeyboard.nOK_EndLoop = _StruscReadKeyboard.nOK_EndLoop + 1;
            if (_StruscReadKeyboard.nOK_EndLoop == 254){_StruscReadKeyboard.nOK_EndLoop = 255;}//korekce preteceni...
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_Max)){//delka stisku 3 sec. Vyskoceni z menu
                _StruscReadKeyboard.nOK_SubMenuLoop = 1; //ukonceni edit submenu
               _BUTTON._bit.TL_OK_BUTTON = 0;
               _StruscReadKeyboard.nOK_EndLoop = 0;
               //kod pro ulozeni editovanych hodnot
               SetTime();
            }
        }
        else {
            _StruscReadKeyboard.nOK_SubMenuLoop = 0;
            _StruscReadKeyboard.nOK_EndLoop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
        }
        //*********************************************************************
        // kod editace a nastaveni hodin
        IndikaceMenuTime();
        switch (_StruscReadKeyboard.position_sub_menu){
                
            case 0 ://editace hodin
               ChangeSegment (& _DateTimeDS3231.Hour_10,& _DateTimeDS3231.Hour, 2, 3);
              break;

            case 1 ://editace minut
               ChangeSegment (&_DateTimeDS3231.Minutes_10,&_DateTimeDS3231.Minutes, 5, 9);
              break;
              
            case 2 ://editace sekund 
              ChangeSegment (&_DateTimeDS3231.Seconds_10,&_DateTimeDS3231.Seconds, 5, 9); 
            break;
              
            default ://default...asi je neco spatne 
                ShowErr();
            break;
        } 
        // kod pro posouvani v menu funkci ... doprava doleva
        if (_BUTTON._bit.TL_LEFT_BUTTON) {
            _BUTTON._bit.TL_LEFT_BUTTON = 0;
            _StruscReadKeyboard.position_sub_menu = (unsigned) _StruscReadKeyboard.position_sub_menu - 1;
            if (_StruscReadKeyboard.position_sub_menu == 255){
                _StruscReadKeyboard.position_sub_menu = _end_menu_edit_time;
            }
        }
        
        if (_BUTTON._bit.TL_RIGHT_BUTTON) {
            _BUTTON._bit.TL_RIGHT_BUTTON = 0;
            _StruscReadKeyboard.position_sub_menu =(unsigned) _StruscReadKeyboard.position_sub_menu + 1;
            if (_StruscReadKeyboard.position_sub_menu >= (_end_menu_edit_time + 1)){
                _StruscReadKeyboard.position_sub_menu = 0;
            }
        }
    }
}
//*****************************************************************************
void ChangeSegment (uint8_t *SegmentHi, uint8_t *SegmetLo, uint8_t MaxSegmentHi, uint8_t MaxSegmentLo){
    if (_BUTTON._bit.TL_UP_BUTTON or _BUTTON._bit.TL_DOWN_BUTTON) {   
        if (_BUTTON._bit.TL_UP_BUTTON){
            _StruscReadKeyboard._SignalButtom = _UP_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani nahoru, tlacitko UP je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                *SegmetLo = *SegmetLo +(unsigned) 1;
                if (*SegmetLo > 9){//novy rad
                    *SegmetLo = 0;
                    *SegmentHi = *SegmentHi + (unsigned)1;
                }
               if ((*SegmentHi > MaxSegmentHi and  *SegmetLo == 0) or (*SegmentHi == MaxSegmentHi and *SegmetLo > MaxSegmentLo)){
                    *SegmentHi = 0;
                    *SegmetLo = 0;
                }
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            }
        }
        if (_BUTTON._bit.TL_DOWN_BUTTON){
            _StruscReadKeyboard._SignalButtom = _DOWN_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani dolu, tlacitko DOWN je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                *SegmetLo = *SegmetLo -(unsigned) 1;
                if (*SegmetLo == 255){//novy rad
                    *SegmetLo = 9;
                    *SegmentHi = *SegmentHi - (unsigned)1;
                }
               if (*SegmentHi == 255 and  *SegmetLo == 9){
                    *SegmentHi = MaxSegmentHi;
                    *SegmetLo = MaxSegmentLo;
                }   
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            } 
        }
    }
    else {
        if (_StruscReadKeyboard._SignalButtom == _UP_){
            if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko UP je stisknuto a volneno, tak se pricte jen jednou
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                *SegmetLo = *SegmetLo +(unsigned) 1;
                if (*SegmetLo > 9){//novy rad
                    *SegmetLo = 0;
                    *SegmentHi = *SegmentHi + (unsigned)1;
                }
               if ((*SegmentHi > MaxSegmentHi and  *SegmetLo == 0) or (*SegmentHi == MaxSegmentHi and *SegmetLo > MaxSegmentLo)){
                    *SegmentHi = 0;
                    *SegmetLo = 0;
                } 
             }
        }
        if (_StruscReadKeyboard._SignalButtom == _DOWN_){
             if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko DOWN je stisknuto a volneno, tak se odecte jen jednou     
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                *SegmetLo = *SegmetLo -(unsigned) 1;
                if (*SegmetLo == 255){//novy rad
                    *SegmetLo = 9;
                    *SegmentHi = *SegmentHi - (unsigned)1;
                }
               if (*SegmentHi == 255 and  *SegmetLo == 9){
                    *SegmentHi = MaxSegmentHi;
                    *SegmetLo = MaxSegmentLo;
                } 
            }
        }
         //nulovani vseho co zpusobuje autorepeat a indikace stisknuti tlacitka
        _StruscReadKeyboard._SpeedFlag = 0;
        _StruscReadKeyboard._SignalButtom = 0;
        _StruscReadKeyboard.nUpDown_Loop = 0;
        _BUTTON._bit.TL_UP_BUTTON = 0; 
    }
}
//*****************************************************************************
void Edit_Datumu (void){
    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
    for(;_StruscReadKeyboard.nOK_SubMenuLoop == 0;){//SubMenu
        ClrWdt ();
        __delay_ms(_menuLoop );
        if (_BUTTON._bit.TL_OK_BUTTON) {
            _StruscReadKeyboard.nOK_EndLoop = _StruscReadKeyboard.nOK_EndLoop + 1;
            if (_StruscReadKeyboard.nOK_EndLoop == 254){_StruscReadKeyboard.nOK_EndLoop = 255;}//korekce preteceni...
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_Max)){//delka stisku 3 sec. Vyskoceni z menu
                _StruscReadKeyboard.nOK_SubMenuLoop = 1; //ukonceni edit submenu
               _BUTTON._bit.TL_OK_BUTTON = 0;
               _StruscReadKeyboard.nOK_EndLoop = 0;
               //kod pro ulozeni editovanych hodnot
               SetDate();    
            }
        }
        else {
            _StruscReadKeyboard.nOK_SubMenuLoop = 0;
            _StruscReadKeyboard.nOK_EndLoop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
        }
        //*********************************************************************
        // kod editace a nastaveni hodin
        IndikaceMenuDate();
        switch (_StruscReadKeyboard.position_sub_menu){
                
            case 0 ://editace poradi dne....Pondeli je 1, utery je 2 atd
                ChangeSegmentDat (& _DateTimeDS3231.Day, NULL, ConsDay);
              break;

            case 1 ://editace datumu
                ChangeSegmentDat (&_DateTimeDS3231.Date, NULL,  ConsDate);
              break;
              
             case 2 ://editace cisla mesice 
                ChangeSegmentDat (&_DateTimeDS3231.Month_Century, NULL,  ConstMonth); 
              break;
              
              case 3 ://editace roku 
                ChangeSegmentDat (&_DateTimeDS3231.Year, &_DateTimeDS3231.Month_Century, ConstYear); 
              break;
              
            default ://default...asi je neco spatne 
                ShowErr();
             break;
        } 
        // kod pro posouvani v menu funkci ... doprava doleva
        if (_BUTTON._bit.TL_LEFT_BUTTON) {
            _BUTTON._bit.TL_LEFT_BUTTON = 0;
            _StruscReadKeyboard.position_sub_menu = (unsigned) _StruscReadKeyboard.position_sub_menu - 1;
            if (_StruscReadKeyboard.position_sub_menu == 255){
                _StruscReadKeyboard.position_sub_menu = _end_menu_edit_date;
            }
        }
        
        if (_BUTTON._bit.TL_RIGHT_BUTTON) {
            _BUTTON._bit.TL_RIGHT_BUTTON = 0;
            _StruscReadKeyboard.position_sub_menu =(unsigned) _StruscReadKeyboard.position_sub_menu + 1;
            if (_StruscReadKeyboard.position_sub_menu >= (_end_menu_edit_date + 1)){
                _StruscReadKeyboard.position_sub_menu = 0;
            }
        }
    }
}
//*****************************************************************************
void ChangeSegmentDat (uint8_t *SegmentSource, uint8_t *Century, uint16_t MaxNumberSegment){
    uint8_t nBuffer;
    uint8_t nBuffer10;
    if (_BUTTON._bit.TL_UP_BUTTON or _BUTTON._bit.TL_DOWN_BUTTON) {   
        if (_BUTTON._bit.TL_UP_BUTTON){
            _StruscReadKeyboard._SignalButtom = _UP_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani nahoru, tlacitko UP je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                switch (MaxNumberSegment){
                   case ConsDay ://editace poradi dne v tydnu 
                        *SegmentSource = *SegmentSource + (unsigned) 1;
                        if (*SegmentSource == 8){*SegmentSource = 1;}
                     break;

                   case ConstMonth ://editace mesice 
                       nBuffer = *SegmentSource;
                       if ((unsigned)((nBuffer and 0b00010000) ror 4) == 1){nBuffer = (unsigned) nBuffer + 10;}
                       BitClear (nBuffer, 4);
                       nBuffer = nBuffer + (unsigned) 1;
                       switch (nBuffer){
                           case 10 :
                               *SegmentSource = 0;
                                BitSet (*SegmentSource, 4);
                            break;

                            case 13 :
                                *SegmentSource = 1;    
                            break;

                            default ://default. 
                                nBuffer = (unsigned)*SegmentSource and 0b00010000; //vytvorit masku 5th bytu
                                BitClear (*SegmentSource, 4);
                                *SegmentSource = *SegmentSource + (unsigned) 1;
                                *SegmentSource = (unsigned)*SegmentSource or nBuffer;
                            break; 
                       }
                     break;

                    case ConsDate ://editace datuma 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        nBuffer = nBuffer + (unsigned) 1;
                        if (nBuffer == 10){
                            *SegmentSource = 0;
                            nBuffer10 = nBuffer10 + (unsigned) 1;
                            *SegmentSource = (unsigned) nBuffer10 rol 4;
                        }
                        else if (nBuffer10 == 3 and nBuffer == 2){
                            *SegmentSource = 1;
                        }

                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b00110000; //vytvorit masku 5th bytu

                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;

                     case ConstYear ://editace roku 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b11110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        BitClear (nBuffer, 6);
                        BitClear (nBuffer, 7);
                        nBuffer = nBuffer + (unsigned) 1;
                        if (nBuffer == 10){
                            *SegmentSource = 0;
                            nBuffer10 = nBuffer10 + (unsigned) 1;
                            *SegmentSource = (unsigned) nBuffer10 rol 4;

                            if (nBuffer10 == 10 and nBuffer == 10){
                                *SegmentSource = 0;
                                nBuffer10 = (unsigned) *Century and 0b10000000;
                                if (nBuffer10 == 0){
                                    BitSet (*Century, 7);
                                }
                                else{
                                    BitClear (*Century, 7);
                                }
                            }
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b11110000; //vytvorit masku 5th bytu

                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            BitClear (*SegmentSource, 6);
                            BitClear (*SegmentSource, 7);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }

                     break;

                   default ://default...asi je neco spatne 
                       ShowErr();
                    break;
               }
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            }
        }
        if (_BUTTON._bit.TL_DOWN_BUTTON){
            _StruscReadKeyboard._SignalButtom = _DOWN_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani dolu, tlacitko DOWN je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                switch (MaxNumberSegment){
                    case ConsDay ://editace poradi dne v tydnu 
                        *SegmentSource = *SegmentSource - (unsigned) 1;
                        if (*SegmentSource == 0){*SegmentSource = 7;}
                       break;
                    case ConstMonth ://editace mesice 
                       nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00010000) ror 4) ;
                        BitClear (nBuffer, 4);
                        nBuffer = nBuffer - (unsigned) 1;

                       if (nBuffer == 255){
                           nBuffer10 = (unsigned)*SegmentSource and 0b10000000; //vytvorit masku Century BITu
                           *SegmentSource =(unsigned) 0b00001001 or nBuffer10;//nastavi segmenty na 0 a 9
                        }
                        else if (nBuffer10 == 0 and nBuffer == 0){
                            nBuffer10 = (unsigned)*SegmentSource and 0b10000000; //vytvorit masku Century BITu
                            *SegmentSource = (unsigned)0b00010010 or nBuffer10;//nastavi segmenty na 1 a 2
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b10010000; //vytvorit masku 5th bytu + Century BIT
                            BitClear (*SegmentSource, 4);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;

                    case ConsDate ://editace datumu 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        nBuffer = nBuffer - (unsigned) 1;
                        if (nBuffer == 255){
                            nBuffer10 = nBuffer10 - (unsigned) 1;
                            *SegmentSource = (unsigned) (nBuffer10 rol 4) or 9;
                        }
                        else if (nBuffer10 == 0 and nBuffer == 0){
                            *SegmentSource = 0b00110001;//nastavi segmenty na 3 a 1
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b00110000; //vytvorit masku 5th bytu

                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;
                      
                    case ConstYear ://editace roku 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b11110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        BitClear (nBuffer, 6);
                        BitClear (nBuffer, 7);
                        nBuffer = nBuffer - (unsigned) 1;
                        if (nBuffer == 0xff){
                            nBuffer10 = nBuffer10 - (unsigned) 1;
                            *SegmentSource = (unsigned) (nBuffer10 rol 4) or 9;
                            if (nBuffer10 == 0xff and nBuffer == 0xff){
                                *SegmentSource = 0b10011001;  // 9 + 9
                                nBuffer10 =(unsigned) *Century and 0b10000000;
                                if (nBuffer10 == 0){
                                    BitSet (*Century, 7);
                                }
                                else{
                                    BitClear (*Century, 7);
                                }
                            }
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b11110000; //vytvorit masku horni poloviny bytu
                            *SegmentSource = nBuffer;
                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            BitClear (*SegmentSource, 6);
                            BitClear (*SegmentSource, 7);
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;
                     
                     default ://default...asi je neco spatne 
                       ShowErr();
                    break;              
                }  
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            } 
        }
    }
    else {
        if (_StruscReadKeyboard._SignalButtom == _UP_){
            if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko UP je stisknuto a volneno, tak se pricte jen jednou
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                switch (MaxNumberSegment){
                   case ConsDay ://editace poradi dne v tydnu 
                        *SegmentSource = *SegmentSource + (unsigned) 1;
                        if (*SegmentSource == 8){*SegmentSource = 1;}
                     break;

                   case ConstMonth ://editace mesice 
                       nBuffer = *SegmentSource;
                       if ((unsigned)((nBuffer and 0b00010000) ror 4) == 1){nBuffer = (unsigned) nBuffer + 10;}
                       BitClear (nBuffer, 4);
                       nBuffer = nBuffer + (unsigned) 1;
                       switch (nBuffer){
                           case 10 :
                               *SegmentSource = 0;
                                BitSet (*SegmentSource, 4);
                            break;

                            case 13 :
                                *SegmentSource = 1;    
                            break;

                            default ://default. 
                                nBuffer = (unsigned)*SegmentSource and 0b00010000; //vytvorit masku 5th bytu
                                BitClear (*SegmentSource, 4);
                                *SegmentSource = *SegmentSource + (unsigned) 1;
                                *SegmentSource = (unsigned)*SegmentSource or nBuffer;
                            break; 
                       }
                     break;

                    case ConsDate ://editace datumu 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        nBuffer = nBuffer + (unsigned) 1;
                        if (nBuffer == 10){
                            *SegmentSource = 0;
                            nBuffer10 = nBuffer10 + (unsigned) 1;
                            *SegmentSource = (unsigned) nBuffer10 rol 4;
                        }
                        else if (nBuffer10 == 3 and nBuffer == 2){
                            *SegmentSource = 1;
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b00110000; //vytvorit masku 5th bytu
                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;

                     case ConstYear ://editace roku 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b11110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        BitClear (nBuffer, 6);
                        BitClear (nBuffer, 7);
                        nBuffer = nBuffer + (unsigned) 1;
                        if (nBuffer == 10){
                            *SegmentSource = 0;
                            nBuffer10 = nBuffer10 + (unsigned) 1;
                            *SegmentSource = (unsigned) nBuffer10 rol 4;
                            if (nBuffer10 == 10 and nBuffer == 10){
                                *SegmentSource = 0;
                                nBuffer10 = (unsigned)*Century and 0b10000000;
                                if (nBuffer10 == 0){
                                    BitSet (*Century, 7);
                                }
                                else{
                                    BitClear (*Century, 7);
                                }
                            }
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b11110000; //vytvorit masku 5th bytu
                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            BitClear (*SegmentSource, 6);
                            BitClear (*SegmentSource, 7);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;

                   default ://default...asi je neco spatne 
                       ShowErr();
                    break;
                }
             }
        }
        if (_StruscReadKeyboard._SignalButtom == _DOWN_){
             if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko DOWN je stisknuto a volneno, tak se odecte jen jednou     
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                switch (MaxNumberSegment){
                    case ConsDay ://editace poradi dne v tydnu 
                        *SegmentSource = *SegmentSource - (unsigned) 1;
                        if (*SegmentSource == 0){*SegmentSource = 7;}
                       break;
                    case ConstMonth ://editace mesice 
                       nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00010000) ror 4) ;
                        BitClear (nBuffer, 4);
                        nBuffer = nBuffer - (unsigned) 1;

                       if (nBuffer == 255){
                           nBuffer10 = (unsigned)*SegmentSource and 0b10000000; //vytvorit masku Century BITu
                           *SegmentSource = (unsigned)0b00001001 or nBuffer10;//nastavi segmenty na 0 a 9
                        }
                        else if (nBuffer10 == 0 and nBuffer == 0){
                            nBuffer10 = (unsigned)*SegmentSource and 0b10000000; //vytvorit masku Century BITu
                            *SegmentSource = (unsigned)0b00010010 or nBuffer10;//nastavi segmenty na 1 a 2
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b10010000; //vytvorit masku 5th bytu + Century BIT
                            BitClear (*SegmentSource, 4);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;

                    case ConsDate ://editace datumu 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b00110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        nBuffer = nBuffer - (unsigned) 1;
                        if (nBuffer == 255){
                            nBuffer10 = nBuffer10 - (unsigned) 1;
                            *SegmentSource = (unsigned) (nBuffer10 rol 4) or 9;
                        }
                        else if (nBuffer10 == 0 and nBuffer == 0){
                            *SegmentSource = 0b00110001;//nastavi segmenty na 3 a 1
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b00110000; //vytvorit masku 5th bytu

                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            *SegmentSource = nBuffer;
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                     break;
                      
                    case ConstYear ://editace roku 
                        nBuffer = *SegmentSource;
                        nBuffer10 = *SegmentSource;
                        nBuffer10 = (unsigned)((nBuffer10 and 0b11110000) ror 4) ;
                        BitClear (nBuffer, 4);
                        BitClear (nBuffer, 5);
                        BitClear (nBuffer, 6);
                        BitClear (nBuffer, 7);
                        nBuffer = nBuffer - (unsigned) 1;
                        if (nBuffer == 0xff){
                            nBuffer10 = nBuffer10 - (unsigned) 1;
                            *SegmentSource = (unsigned) (nBuffer10 rol 4) or 9;
                            if (nBuffer10 == 0xff and nBuffer == 0xff){
                                *SegmentSource = 0b10011001;  // 9 + 9
                                nBuffer10 = (unsigned)*Century and 0b10000000;
                                if (nBuffer10 == 0){
                                    BitSet (*Century, 7);
                                }
                                else{
                                    BitClear (*Century, 7);
                                }
                            }
                        }
                        else {
                            nBuffer10 = (unsigned)*SegmentSource and 0b11110000; //vytvorit masku horni poloviny bytu
                            *SegmentSource = nBuffer;
                            BitClear (*SegmentSource, 4);
                            BitClear (*SegmentSource, 5);
                            BitClear (*SegmentSource, 6);
                            BitClear (*SegmentSource, 7);
                            *SegmentSource = (unsigned)*SegmentSource or nBuffer10;
                        }
                    break;
                     
                    default ://default...asi je neco spatne 
                       ShowErr();
                    break;                     
                }
            }
        }
         //nulovani vseho co zpusobuje autorepeat a indikace stisknuti tlacitka
        _StruscReadKeyboard._SpeedFlag = 0;
        _StruscReadKeyboard._SignalButtom = 0;
        _StruscReadKeyboard.nUpDown_Loop = 0;
        _BUTTON._bit.TL_UP_BUTTON = 0; 
    }
}
//*****************************************************************************
void ShowDate (void){
    __delay_ms(100);
    ClrWdt ();
    ShowDayDateMonth();
    ClrWdt ();
    __delay_ms(1700);
    ShowYear();
    ClrWdt ();
   __delay_ms(1700);
    ShowDayDateMonth();
    ClrWdt ();
    __delay_ms(1700);
    ShowYear(); 
    ClrWdt ();
    __delay_ms(1700);
}
//*****************************************************************************
void ShowDayDateMonth(void){
    _hour_raw (decode_segment(_DateTimeDS3231.Day),decode_segment(21));//show number day
    _minut_raw (decode_segment((unsigned)(_DateTimeDS3231.Date and 0b00110000) ror 4),decode_segment((unsigned)_DateTimeDS3231.Date and 0b00001111));//show date
    _second_raw (decode_segment((unsigned)(_DateTimeDS3231.Month_Century and 0b00010000) ror 4),decode_segment((unsigned)_DateTimeDS3231.Month_Century and 0b00001111));//show month
}
//*****************************************************************************
void ShowYear (void){
    _hour_raw (decode_segment(21),decode_segment(21));//show empty char
    _minut_raw (decode_segment(2),decode_segment((unsigned)(_DateTimeDS3231.Month_Century and 0b10000000) ror 7));//show 2 + century
    _second_raw (decode_segment(((unsigned)_DateTimeDS3231.Year and 0b11110000) ror 4),decode_segment((unsigned)_DateTimeDS3231.Year and 0b00001111));//show year
}
//*****************************************************************************     
void Edit_Podsvetleni(void){
    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
    _StruscReadKeyboard.position_sub_menu = 0;
    for(;_StruscReadKeyboard.nOK_SubMenuLoop == 0;){//SubMenu
        ClrWdt ();
        __delay_ms(_menuLoop );
        if (_BUTTON._bit.TL_OK_BUTTON) {
            _StruscReadKeyboard.nOK_EndLoop = _StruscReadKeyboard.nOK_EndLoop + 1;
            if (_StruscReadKeyboard.nOK_EndLoop == 254){_StruscReadKeyboard.nOK_EndLoop = 255;}//korekce preteceni...
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_Max)){//delka stisku 3 sec. Vyskoceni z menu
                _StruscReadKeyboard.nOK_SubMenuLoop = 1; //ukonceni edit submenu
               _BUTTON._bit.TL_OK_BUTTON = 0;
               _StruscReadKeyboard.nOK_EndLoop = 0;
               _StruscReadKeyboard.position_sub_menu = 0;
               _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
               //kod pro ulozeni editovanych hodnot
               WriteEEprom();
            }
        }
        else {
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nOK_EndLoop <= (_Delka_stisku_tlacitka_HorniMer)){//potvrzeni funkce. Vnoreni do podmenu
                _StruscReadKeyboard.nOK_SubMenuHLSLoop = 1;
            }
            _StruscReadKeyboard.nOK_SubMenuLoop = 0;
            _StruscReadKeyboard.nOK_EndLoop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
        }      
        //*********************************************************************
        // kod editace a nastaveni podsvetleni
        IndikaceMenuHLS_ALL();
        switch (_StruscReadKeyboard.position_sub_menu){
                
            case IC2 ://editace IC2
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC2
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC2_PWM.h, (unsigned char *)&PoleLedHSL.IC2_PWM.s, (unsigned char *)&PoleLedHSL.IC2_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                }
            break;

            case 1 ://editace IC3 
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC3
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC3_PWM.h, (unsigned char *)&PoleLedHSL.IC3_PWM.s, (unsigned char *)&PoleLedHSL.IC3_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                }
            break;
              
            case 2 ://editace IC4  
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC4
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC4_PWM.h, (unsigned char *)&PoleLedHSL.IC4_PWM.s, (unsigned char *)&PoleLedHSL.IC4_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                }
            break;
            
            case 3 ://editace IC5  
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC5
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC5_PWM.h, (unsigned char *)&PoleLedHSL.IC5_PWM.s, (unsigned char *)&PoleLedHSL.IC5_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                } 
            break;
            
            case 4 ://editace IC6  
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC6
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC6_PWM.h, (unsigned char *)&PoleLedHSL.IC6_PWM.s, (unsigned char *)&PoleLedHSL.IC6_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                } 
            break;
            
            case 5 ://editace IC7  
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu IC7
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC7_PWM.h, (unsigned char *)&PoleLedHSL.IC7_PWM.s, (unsigned char *)&PoleLedHSL.IC7_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                } 
            break;
            
            case 6 ://editace ALL led for itrons 
                if (_StruscReadKeyboard.nOK_SubMenuHLSLoop == 1){//editace Sub_Sub_menu ALL
                    _BUTTON._bit.TL_OK_BUTTON = 0;
                    _StruscReadKeyboard._tagALL = _true;
                    ChangeSegment_HLS_ALL ((unsigned char *)&PoleLedHSL.IC2_PWM.h, (unsigned char *)&PoleLedHSL.IC2_PWM.s, (unsigned char *)&PoleLedHSL.IC2_PWM.v);
                    _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
                    _StruscReadKeyboard._tagALL = _false;
                    _StruscReadKeyboard.nOK_EndLoop = 0;
                }
            break;
              
            default ://default...asi je neco spatne 
                ShowErr();
            break;
        } 
        // kod pro posouvani v menu funkci ... doprava doleva
        if (_BUTTON._bit.TL_LEFT_BUTTON) {
            _BUTTON._bit.TL_LEFT_BUTTON = 0;
            _StruscReadKeyboard.DT_blik_Loop = 0; // nulovani pocitadla pocitani blikani
            _StruscReadKeyboard.DT_blik == 1; // nastavrni sviceni
            _StruscReadKeyboard.position_sub_menu = (unsigned) _StruscReadKeyboard.position_sub_menu - 1;
            if (_StruscReadKeyboard.position_sub_menu == 255){
                _StruscReadKeyboard.position_sub_menu = _end_menu_HLS_ALL;
            }
        }
        
        if (_BUTTON._bit.TL_RIGHT_BUTTON) {
            _BUTTON._bit.TL_RIGHT_BUTTON = 0;
            _StruscReadKeyboard.DT_blik_Loop = 0; // nulovani pocitadla pocitani blikani
            _StruscReadKeyboard.DT_blik == 1; // nastavrni sviceni
            _StruscReadKeyboard.position_sub_menu =(unsigned) _StruscReadKeyboard.position_sub_menu + 1;
            if (_StruscReadKeyboard.position_sub_menu >= (_end_menu_HLS_ALL + 1)){
                _StruscReadKeyboard.position_sub_menu = 0;
            }
        }
    }
}
//*****************************************************************************
     
void ChangeSegment_HLS_ALL(unsigned char *_Hue, unsigned char *_Saturation, unsigned char *_Lightness){
    _StruscReadKeyboard.nOK_SubMenuLoop = 0;
    _StruscReadKeyboard.position_sub_menuHLS = 0;
    for(;_StruscReadKeyboard.nOK_SubMenuLoop == 0;){//SubMenu
        ClrWdt ();
        __delay_ms(_menuLoop );
        
        //PrintHex(1,*_Hue);
        //   PrintHex(2,*_Saturation);
        //   PrintHex(3,*_Lightness);
           
        if (_BUTTON._bit.TL_OK_BUTTON) {
            _StruscReadKeyboard.nOK_EndLoop = _StruscReadKeyboard.nOK_EndLoop + 1;
            if (_StruscReadKeyboard.nOK_EndLoop == 254){_StruscReadKeyboard.nOK_EndLoop = 255;}//korekce preteceni...
            if (_StruscReadKeyboard.nOK_EndLoop >= (_Delka_stisku_tlacitka_Max)){//delka stisku 3 sec. Vyskoceni z menu
                _StruscReadKeyboard.nOK_SubMenuLoop = 1; //ukonceni edit submenu
               _BUTTON._bit.TL_OK_BUTTON = 0;
               _StruscReadKeyboard.nOK_EndLoop = 0;
               _StruscReadKeyboard.position_sub_menuHLS = 0;
               _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
               //kod pro ulozeni editovanych hodnot
               //WriteEEprom();
            }
        }
        else {
            _StruscReadKeyboard.nOK_SubMenuLoop = 0;
            _StruscReadKeyboard.nOK_SubMenuHLSLoop = 0;
            _StruscReadKeyboard.nOK_EndLoop = 0;
            _BUTTON._bit.TL_OK_BUTTON = 0;
        }
        //*********************************************************************
        // kod editace a nastaveni podsvetleni
        IndikaceMenuSegment_HLS_ALL((unsigned char *)_Hue, (unsigned char *)_Saturation, (unsigned char *)_Lightness);
        switch (_StruscReadKeyboard.position_sub_menuHLS){
                
            case 0 ://editace IC2
                ChangeHLS_ALL ((unsigned char *)_Hue);
            break;   

            case 1 ://editace IC3 
              ChangeHLS_ALL ((unsigned char *)_Saturation);
            break;
              
            case 2 ://editace IC4  
             ChangeHLS_ALL ((unsigned char *)_Lightness); 
            break;
            
              
            default ://default...asi je neco spatne 
                ShowErr();
            break;
        } 
        // kod pro posouvani v menu funkci ... doprava doleva
        if (_BUTTON._bit.TL_LEFT_BUTTON) {
            _BUTTON._bit.TL_LEFT_BUTTON = 0;
            _StruscReadKeyboard.DT_blik_Loop = 0; // nulovani pocitadla pocitani blikani
            _StruscReadKeyboard.DT_blik == 1; // nastavrni sviceni
            _StruscReadKeyboard.position_sub_menuHLS = (unsigned) _StruscReadKeyboard.position_sub_menuHLS - 1;
            if (_StruscReadKeyboard.position_sub_menuHLS == 255){
                _StruscReadKeyboard.position_sub_menuHLS = _end_menuSegment_HLS_ALL;
            }
        }
        
        if (_BUTTON._bit.TL_RIGHT_BUTTON) {
            _BUTTON._bit.TL_RIGHT_BUTTON = 0;
            _StruscReadKeyboard.DT_blik_Loop = 0; // nulovani pocitadla pocitani blikani
            _StruscReadKeyboard.DT_blik == 1; // nastavrni sviceni
            _StruscReadKeyboard.position_sub_menuHLS =(unsigned) _StruscReadKeyboard.position_sub_menuHLS + 1;
            if (_StruscReadKeyboard.position_sub_menuHLS >= (_end_menuSegment_HLS_ALL + 1)){
                _StruscReadKeyboard.position_sub_menuHLS = 0;
            }
        }
    }
}
//*****************************************************************************
void _HLS_ALL (void){
    if (_StruscReadKeyboard._tagALL == _true){
    PoleLedHSL.IC3_PWM.h = PoleLedHSL.IC2_PWM.h; 
    PoleLedHSL.IC4_PWM.h = PoleLedHSL.IC2_PWM.h;
    PoleLedHSL.IC5_PWM.h = PoleLedHSL.IC2_PWM.h;
    PoleLedHSL.IC6_PWM.h = PoleLedHSL.IC2_PWM.h;
    PoleLedHSL.IC7_PWM.h = PoleLedHSL.IC2_PWM.h;
    
    PoleLedHSL.IC3_PWM.s = PoleLedHSL.IC2_PWM.s; 
    PoleLedHSL.IC4_PWM.s = PoleLedHSL.IC2_PWM.s;
    PoleLedHSL.IC5_PWM.s = PoleLedHSL.IC2_PWM.s;
    PoleLedHSL.IC6_PWM.s = PoleLedHSL.IC2_PWM.s;
    PoleLedHSL.IC7_PWM.s = PoleLedHSL.IC2_PWM.s;
    
    PoleLedHSL.IC3_PWM.v = PoleLedHSL.IC2_PWM.v; 
    PoleLedHSL.IC4_PWM.v = PoleLedHSL.IC2_PWM.v;
    PoleLedHSL.IC5_PWM.v = PoleLedHSL.IC2_PWM.v;
    PoleLedHSL.IC6_PWM.v = PoleLedHSL.IC2_PWM.v;
    PoleLedHSL.IC7_PWM.v = PoleLedHSL.IC2_PWM.v;
    }
}
//*****************************************************************************
void ChangeHLS_ALL (unsigned char *_Tag){
    if (_BUTTON._bit.TL_UP_BUTTON or _BUTTON._bit.TL_DOWN_BUTTON) {   
        if (_BUTTON._bit.TL_UP_BUTTON){
            _StruscReadKeyboard._SignalButtom = _UP_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani nahoru, tlacitko UP je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                //*****************************************************************************
                *_Tag = *_Tag + (unsigned)1;
                _HLS_ALL ();
                SetLightHua();
                //*****************************************************************************
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            }
        }
        if (_BUTTON._bit.TL_DOWN_BUTTON){
            _StruscReadKeyboard._SignalButtom = _DOWN_;
            if (_StruscReadKeyboard._SpeedFlag == 1){//rychle pocitani dolu, tlacitko DOWN je stisknute a porad je drzeno, takze se jedna o autorepeat
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                //*****************************************************************************
                *_Tag = *_Tag - (unsigned)1;
                _HLS_ALL ();
                SetLightHua();
                //*****************************************************************************
            }
            else {
                _StruscReadKeyboard.nUpDown_Loop = _StruscReadKeyboard.nUpDown_Loop + 1;
                if (_StruscReadKeyboard.nUpDown_Loop == 254){_StruscReadKeyboard.nUpDown_Loop = 255;}//korekce preteceni...
                if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_HorniMer)){//delka stisku 3 sec. Vyskoceni z menu
                    _StruscReadKeyboard._SpeedFlag = 1;
                }
            } 
        }
    }
    else {
        if (_StruscReadKeyboard._SignalButtom == _UP_){
            if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko UP je stisknuto a volneno, tak se pricte jen jednou
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                //*****************************************************************************
                *_Tag = *_Tag + (unsigned)1;
                _HLS_ALL ();
                SetLightHua();
                //*****************************************************************************  
            }     
        }
        if (_StruscReadKeyboard._SignalButtom == _DOWN_){
             if (_StruscReadKeyboard.nUpDown_Loop >= (_Delka_stisku_tlacitka_DolniMer) and _StruscReadKeyboard.nUpDown_Loop <= (_Delka_stisku_tlacitka_HorniMer)){
                // tlacitko DOWN je stisknuto a volneno, tak se odecte jen jednou     
                _StruscReadKeyboard.DT_blik = 0; //Zobrazeni segmentu
                _StruscReadKeyboard.DT_blik_Loop = 0;//Nulovani pocitani kdy zacit blikat
                //*****************************************************************************
                *_Tag = *_Tag - (unsigned)1;
                _HLS_ALL ();
                SetLightHua();
                //*****************************************************************************  
             }    
        }
         //nulovani vseho co zpusobuje autorepeat a indikace stisknuti tlacitka
        _StruscReadKeyboard._SpeedFlag = 0;
        _StruscReadKeyboard._SignalButtom = 0;
        _StruscReadKeyboard.nUpDown_Loop = 0;
        _BUTTON._bit.TL_UP_BUTTON = 0; 
    } 
}
//*****************************************************************************
void IndikaceMenuHLS_ALL (void){
    //funkce indikuje editovany udaj...pomoci blikani patricne desetinne tecky, v rezimu ALL blikaji vsechny desetinne tecky
    
    _StruscReadKeyboard.DT_blik_Loop = (unsigned)_StruscReadKeyboard.DT_blik_Loop + 1;
    if (_StruscReadKeyboard.DT_blik_Loop == _change_DT_Const){//provede se zmena stavu DT
        _StruscReadKeyboard.DT_blik_Loop = 0;
        DTstatus();
    }

    if (_StruscReadKeyboard.DT_blik == 0) {     
        ClearALL_Dot();
    }
    
    switch (_StruscReadKeyboard.position_sub_menu){
       case IC2 ://editace IC2
           PrintHex(1,PoleLedHSL.IC2_PWM.h);
           PrintHex(2,PoleLedHSL.IC2_PWM.s);
           PrintHex(3,PoleLedHSL.IC2_PWM.v);
           if (_StruscReadKeyboard.DT_blik == 1) {
               ClearALL_Dot();
               BitSet(TTL_HourHi_LAT, TTL_Segment_DT_D);
           }
        break;

        case IC3 ://editace IC3
           PrintHex(1,PoleLedHSL.IC3_PWM.h);
           PrintHex(2,PoleLedHSL.IC3_PWM.s);
           PrintHex(3,PoleLedHSL.IC3_PWM.v);
           if (_StruscReadKeyboard.DT_blik == 1) {
               ClearALL_Dot();
               BitSet(TTL_HourLo_LAT, TTL_Segment_DT_E);
           }
        break;

        case IC4 ://editace IC4 
           PrintHex(1,PoleLedHSL.IC4_PWM.h);
           PrintHex(2,PoleLedHSL.IC4_PWM.s);
           PrintHex(3,PoleLedHSL.IC4_PWM.v);
           if (_StruscReadKeyboard.DT_blik == 1) {
               ClearALL_Dot();
               BitSet(TTL_MinitHi_LAT, TTL_Segment_DT_H);
            }
        break;

        case IC5 ://editace IC5  
           PrintHex(1,PoleLedHSL.IC5_PWM.h);
           PrintHex(2,PoleLedHSL.IC5_PWM.s);
           PrintHex(3,PoleLedHSL.IC5_PWM.v);
           if (_StruscReadKeyboard.DT_blik == 1) {
               ClearALL_Dot();
               BitSet(TTL_MinitLo_LAT, TTL_Segment_DT_J);
            }
        break;

        case IC6 ://editace IC6
           PrintHex(1,PoleLedHSL.IC6_PWM.h);
           PrintHex(2,PoleLedHSL.IC6_PWM.s);
           PrintHex(3,PoleLedHSL.IC6_PWM.v);
           if (_StruscReadKeyboard.DT_blik == 1) {
               ClearALL_Dot();
               BitSet(TTL_SecondHi_LAT, TTL_Segment_DT_F);
            }
        break;

        case IC7 ://editace IC7
            PrintHex(1,PoleLedHSL.IC7_PWM.h);
            PrintHex(2,PoleLedHSL.IC7_PWM.s);
            PrintHex(3,PoleLedHSL.IC7_PWM.v);
            if (_StruscReadKeyboard.DT_blik == 1) {
                ClearALL_Dot();
                BitSet(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
            }
        break;

        case IC_ALL ://editace ALL led for itrons 
            PrintSpace(1);
            PrintSpace(2);
            PrintSpace(3);
            if (_StruscReadKeyboard.DT_blik == 1) {
                BitSet(TTL_HourHi_LAT, TTL_Segment_DT_D);
                BitSet(TTL_HourLo_LAT, TTL_Segment_DT_E);
                BitSet(TTL_MinitHi_LAT, TTL_Segment_DT_H);
                BitSet(TTL_MinitLo_LAT, TTL_Segment_DT_J);
                BitSet(TTL_SecondHi_LAT, TTL_Segment_DT_F);
                BitSet(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
            }
        break;

        default ://default...asi je neco spatne 
            ShowErr();
        break;
    }  
}
//*****************************************************************************
void ClearALL_Dot (void){
    BitClear(TTL_HourHi_LAT, TTL_Segment_DT_D);
    BitClear(TTL_HourLo_LAT, TTL_Segment_DT_E);
    BitClear(TTL_MinitHi_LAT, TTL_Segment_DT_H);
    BitClear(TTL_MinitLo_LAT, TTL_Segment_DT_J);
    BitClear(TTL_SecondHi_LAT, TTL_Segment_DT_F);
    BitClear(TTL_SecondLoC_LAT, TTL_Segment_DT_C);
}
//*****************************************************************************
void IndikaceMenuSegment_HLS_ALL (unsigned char *_Hue, unsigned char *_Saturation, unsigned char *_Lightness){
    //funkce indikuje editovany udaj...pomoci blikani patricne dvojcislice
    
    _StruscReadKeyboard.DT_blik_Loop = (unsigned)_StruscReadKeyboard.DT_blik_Loop + 1;
    if (_StruscReadKeyboard.DT_blik_Loop == _change_DT_Const){//provede se zmena stavu DT
        _StruscReadKeyboard.DT_blik_Loop = 0;
        DTstatus();
    }
    //nacteni a zobrazeni editovaneho udeje
    PrintHex(1,*_Hue);
    PrintHex(2,*_Saturation);
    PrintHex(3,*_Lightness);
    switch (_StruscReadKeyboard.position_sub_menuHLS){

        case 0 ://editace casu 
            if (_StruscReadKeyboard.DT_blik == 1) {
                _hour_raw (decode_segment(21),decode_segment(21));
            }
          break;

        case 1 ://editace datumu 
            if (_StruscReadKeyboard.DT_blik ==1) {
                _minut_raw (decode_segment(21),decode_segment(21));
            }
          break;

         case 2 ://editace podsvetleni 
             if (_StruscReadKeyboard.DT_blik ==1) {
                _second_raw (decode_segment(21),decode_segment(21));
            }
          break;

        default ://default...asi je neco spatne 
            ShowErr();
         break;
    }      
}
void IndikaceMenuTime (void){
    //funkce indikuje editovany udaj...pomoci blikani patricne dvojcislice
    
    _StruscReadKeyboard.DT_blik_Loop = (unsigned)_StruscReadKeyboard.DT_blik_Loop + 1;
    if (_StruscReadKeyboard.DT_blik_Loop == _change_DT_Const){//provede se zmena stavu DT
        _StruscReadKeyboard.DT_blik_Loop = 0;
        DTstatus();
    }
    //nacteni a zobrazeni casu na editaci
    _hour_raw (decode_segment(_DateTimeDS3231.Hour_10),decode_segment(_DateTimeDS3231.Hour));
    _minut_raw (decode_segment(_DateTimeDS3231.Minutes_10),decode_segment(_DateTimeDS3231.Minutes));
    _second_raw (decode_segment(_DateTimeDS3231.Seconds_10),decode_segment(_DateTimeDS3231.Seconds));
    switch (_StruscReadKeyboard.position_sub_menu){

        case 0 ://editace casu 
            if (_StruscReadKeyboard.DT_blik == 1) {
                _hour_raw (decode_segment(21),decode_segment(21));
            }
          break;

        case 1 ://editace datumu 
            if (_StruscReadKeyboard.DT_blik ==1) {
                _minut_raw (decode_segment(21),decode_segment(21));
            }
          break;

         case 2 ://editace podsvetleni 
             if (_StruscReadKeyboard.DT_blik ==1) {
                _second_raw (decode_segment(21),decode_segment(21));
            }
          break;

        default ://default...asi je neco spatne 
            ShowErr();
         break;
    }  
}
//*****************************************************************************
void IndikaceMenuDate (void){
    //funkce indikuje editovany udaj...pomoci blikani patricne dvojcislice
    
    _StruscReadKeyboard.DT_blik_Loop = (unsigned)_StruscReadKeyboard.DT_blik_Loop + 1;
    if (_StruscReadKeyboard.DT_blik_Loop == _change_DT_Const){//provede se zmena stavu DT
        _StruscReadKeyboard.DT_blik_Loop = 0;
        DTstatus();
    }
    //nacteni a zobrazeni datumu na editaci
    if (_StruscReadKeyboard.position_sub_menu == 3){ShowYear();}
    else {     
        ShowDayDateMonth();
    }
    switch (_StruscReadKeyboard.position_sub_menu){

        case 0 ://editace dnu v tydnu 
            if (_StruscReadKeyboard.DT_blik == 1) {
                _hour_raw (decode_segment(21),decode_segment(21));
            }
          break;

        case 1 ://editace Date 
            if (_StruscReadKeyboard.DT_blik ==1) {
                _minut_raw (decode_segment(21),decode_segment(21));
            }
          break;

         case 2 ://editace Month 
             if (_StruscReadKeyboard.DT_blik ==1) {
                _second_raw (decode_segment(21),decode_segment(21));
            }
          break;
          
         case 3 ://editace Year 
             if (_StruscReadKeyboard.DT_blik ==1) {
                 _minut_raw (decode_segment(21),decode_segment(21));
                _second_raw (decode_segment(21),decode_segment(21));
            }
          break;

        default ://default...asi je neco spatne 
            ShowErr();
         break;
    }  
}