//*****************************************************************************
//
// File Name	: 'keyboard.h'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 05-05-2017, 15:07
// Revised		: 05-05-2017, 15:07
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

#ifndef keyboard_LIB
#define keyboard_LIB

#include "ledI2C.h"

#define Output 0
#define Input 1
#define BitTest(_registr, _bit)  (_registr & (0x01 << _bit))
#define BIT_0 1
#define BIT_1 2
#define BIT_2 4
#define BIT_3 8
#define BIT_4 16
#define BIT_5 32
#define BIT_6 64
#define BIT_7 128
#define and   &
#define or    |
#define ror   >>
#define rol   <<
#define BTFSC(_registr, _bit)  (_registr & _bit) != 0
#define BitSet(_registr, _bit)   (_registr |= (1<<_bit))		// definuje nastaven bitu
#define BitClear(_registr, _bit) (_registr &= ~(1<<_bit))       // definuje vynulovn bitu
#define BitNeg(_registr, _bit)   (_registr ^= (1<<_bit))		// definuje negovn bitu
#define _true  1
#define _false 0

//*****************************************************************************
#define adress_keyboard_write           0b01000010 //HW I2C
#define adress_keyboard_read            0b01000011 //HW I2C
#define Input_Port_0                    0b00000000 //Read byte
#define Input_Port_1                    0b00000001 //Read byte
#define Polarity_Inversion_Port_0       0x04 //Read/write byte
#define Polarity_Inversion_Port_1       0x05 //Read/write byte
#define Configuration_Port_0            0x06 //Read/write byte
#define Configuration_Port_1            0x07 //Read/write byte
#define _LEFT_                          BIT_4
#define _RIGHT_                         BIT_0
#define _OK_                            BIT_1
#define _UP_                            BIT_3
#define _DOWN_                          BIT_2
#define _TL_OK                          _StruscReadKeyboard._Input_Port_0 and _OK_
#define _TL_LEFT                        _StruscReadKeyboard._Input_Port_0 and _LEFT_
#define _TL_RIGHT                       _StruscReadKeyboard._Input_Port_0 and _RIGHT_
#define _TL_UP                          _StruscReadKeyboard._Input_Port_0 and _UP_
#define _TL_DOWN                        _StruscReadKeyboard._Input_Port_0 and _DOWN_
#define TL_OK                           ((_TL_OK) == _OK_)
#define TL_LEFT                         ((_TL_LEFT) == _LEFT_)
#define TL_RIGHT                        ((_TL_RIGHT) == _RIGHT_)
#define TL_UP                           ((_TL_UP) == _UP_)
#define TL_DOWN                         ((_TL_DOWN) == _DOWN_)
#define _change_DT_Const                100
#define _end_menu                       3
#define _end_menu_edit_time             2
#define _end_menu_edit_date             3
#define _end_menu_HLS_ALL               6
#define _end_menuSegment_HLS_ALL        2
#define _menuLoop                       4
#define ConsDay                         7
#define ConsDate                        31
#define ConstMonth                      12
#define ConstYear                       2199

#define tRB2_INT2                       TRISB
#define RB2_INT2                        LATB
#define INT2                            2
#define _Delka_stisku_tlacitka_DolniMer 10
#define _Delka_stisku_tlacitka_HorniMer 100
#define _Delka_stisku_tlacitka_Max      255

#define IC2                             0
#define IC3                             1
#define IC4                             2
#define IC5                             3
#define IC6                             4
#define IC7                             5
#define IC_ALL                          6

//_StruscReadKeyboard._Input_Port_0 and _OK == _true
struct {      
      unsigned char _Input_Port_0;        
      unsigned char _Input_Port_1; 
      int nOK_loop;
      int nOK_EndLoop;
      int nUpDown_Loop;
      int nOK_SubMenuLoop;
      int nOK_SubMenuHLSLoop;
      uint8_t position_menu;
      uint8_t position_sub_menu;
      uint8_t position_sub_menuHLS;
      uint8_t _tagALL;
      uint16_t DT_blik_Loop;//pocitadlo kdy zmenit stav DT
      uint8_t DT_blik;//indikuje zda sviti a nebo nesviti DT
      uint8_t _SpeedFlag; //indikuje rychly posun cisel nahoru/dolu
      uint8_t _SignalButtom; // indikuje zda v predchozim prubehy bylo stisknute tlacitko a jake...
    }_StruscReadKeyboard;
    
//volatile uint8_t TL_OK_BTNBLOCK = 0;
//volatile uint8_t TL_OK_BUTTON   = 0;
//Deklarace volatile (nestl) znamen, ze k obsahu promenn muze pristupovat jeste nejak jin proces nez ten, kter je ?zen aktulnm zdrojovm kdem. 
//M??e to bt nap?klad soub??n b??c vlkno jinho procesu, hardwarov p?eru?en nebo samotn hardware. ?e je prom?nn ozna?ena jako volatile, je?t? neznamen, 
//?e operace s n jsou atomick.
union{
    struct {         
        unsigned TL_OK_BTNBLOCK     : 1;         
        unsigned TL_LEFT_BTNBLOCK   : 1;           
        unsigned TL_RIGHT_BTNBLOCK  : 1;  
        unsigned TL_UP_BTNBLOCK     : 1;  
        unsigned TL_DOWN_BTNBLOCK   : 1;

        unsigned reserve1_BTNBLOCK  : 1;
        unsigned reserve2_BTNBLOCK  : 1;
        unsigned reserve3_BTNBLOCK  : 1;
    } _bit;
   unsigned char BTNBLOCKlo;
}_BTNBLOCKlo;

//union _keyboard{
union{
	 struct _keyboard_{
		 unsigned TL_OK_BUTTON       : 1;
		 unsigned TL_LEFT_BUTTON     : 1;
		 unsigned TL_RIGHT_BUTTON    : 1;
		 unsigned TL_UP_BUTTON       : 1;
		 unsigned TL_DOWN_BUTTON     : 1;
		 
		 unsigned reserve1_BUTTON    : 1;
		 unsigned reserve2_BUTTON    : 1;
		 unsigned reserve3_BUTTON    : 1;
	 } _bit;
   unsigned char BUTTON;
}_BUTTON;




void init_keyboard_PCA955PW (void);
void Read_keyboard_PCA955PW (void);
void Menu_Keyboard (void);
void Edit (void);
void IndikaceMenu (void);
void DTstatus (void);
void ClearSetDT (void);
void _initInterrupt(void);
void Edit_Time (void);
void Edit_Datumu (void);
void Edit_Podsvetleni(void);
void IndikaceMenuTime (void);
void ChangeSegment (uint8_t *SegmentHi, uint8_t *SegmetLo, uint8_t MaxSegmentHi, uint8_t MaxSegmentLo);
void ChangeSegmentDat (uint8_t *SegmentSource, uint8_t *Century, uint16_t MaxNumberSegment);
void ShowDate (void);
void ShowDayDateMonth(void);
void ShowYear (void);
void IndikaceMenuDate (void);
void IndikaceMenuHLS_ALL (void);
void ChangeHLS_ALL (unsigned char *_Tag);
void IndikaceMenuSegment_HLS_ALL (unsigned char *_Hue, unsigned char *_Saturation, unsigned char *_Lightness);
void ClearALL_Dot (void);
void ChangeSegment_HLS_ALL(unsigned char *_Hue, unsigned char *_Saturation, unsigned char *_Lightness);
void _HLS_ALL (void);


#endif