//*****************************************************************************
//
// File Name	: 'ledI2C.h'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 24-05-2017, 13:40
// Revised		: 24-05-2017, 13:40
// Version		: 1.0
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************


// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */
#ifndef ledI2C_LIB
#define ledI2C_LIB

#include "hsv.h"
//*****************************************************************************

#define adress_LED_IC2         0b11000000 //HW I2C
#define adress_LED_IC3         0b11000100 //HW I2C
#define adress_LED_IC4         0b11000010 //HW I2C
#define adress_LED_IC5         0b11000110 //HW I2C
#define adress_LED_IC6         0b11000000 //SW I2C
#define adress_LED_IC7         0b11000010 //SW I2C

#define ACKNOWLEDGE             1
#define NOT_ACKNOWLEDGE         0
#define SSPIF                   3

#define BitTest(_registr, _bit)  (_registr & (0x01 << _bit))
#define BitSet(_registr, _bit)   (_registr |= (1<<_bit))		// definuje nastaven bitu
#define BitClear(_registr, _bit) (_registr &= ~(1<<_bit))	// definuje vynulovn bitu
#define BitNeg(_registr, _bit)   (_registr ^= (1<<_bit))		// definuje negovn bitu


#define PCA9633led0 0x02
#define PCA9633led1 0x03
#define PCA9633led2 0x04
#define PCA9633led3 0x05

#define Hue         0x0
#define Lightness   0x01
#define Saturation  0x02
#define ALL_Itrons  0xff

/*struct {      
    HsvColor hsv;
    RgbColor rgb;

    unsigned char R;
    unsigned char G;
    unsigned char B;

    int minHua;
    int minLightness;
    int maxHua;
    int maxLightness;
    unsigned char nMin, nMax, nMin2, nMax2;
    int z;
}_LedLightHua;*/

/*typedef struct HSL_Color{
    uint8_t _Hue;
    uint8_t _Saturation;
    uint8_t _Lightness;
} HSL_Color;*/


typedef struct {   
       HsvColor IC2_PWM;          
       HsvColor IC3_PWM;  
       HsvColor IC4_PWM;  
       HsvColor IC5_PWM;  
       HsvColor IC6_PWM;  
       HsvColor IC7_PWM;  
}_LED_PWM_registers;

volatile _LED_PWM_registers PoleLedHSL;
//void InitBright9633SW(void);
//void Init9633SW(void);
void InitIO_PCA9633_HW(uint8_t IO_adress);
void InitIO_PCA9633_SW(uint8_t IO_adress);
void setRGB_PCA9633(uint8_t type,uint8_t IO_adress, uint8_t R, uint8_t G, uint8_t B);
void setRGB_PCA9633_SW(uint8_t IO_adress, uint8_t R, uint8_t G, uint8_t B);
void setRGB_PCA9633_HW(uint8_t IO_adress, uint8_t R, uint8_t G, uint8_t B);
void SetLightHua (void);
int ABS(int a);

#endif
