//*****************************************************************************
//
// File Name	: 'rtc.h'
// Title		: Itronove hodiny 
#define __PIC18F8720A__
// Author		: http://www.prochazka.zde.cz -> hacesoft 2017
// Created		: 05-05-2017, 15:05
// Revised		: 07-09-2017, 10:30
// Version		: 1.1
// Target MCU	: PIC 18F8720
//
// This code is distributed under the GNU Public License
// Vsechny informace jsou zahrnuty pod GPL licenci, pokud nen explicitne uveden jin typ licence.
// Pouzivn techto strnek ke komercnm celum lze jen se souhlasem autora.
// Vsechna prva vyhrazena (c) 1997 - 2017 hacesoft.
//
//*****************************************************************************

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

#ifndef rtc_LIB
#define rtc_LIB

#define Output 0
#define Input 1
#define and                     &
#define or                      |
#define BitTest(_registr, _bit)  (_registr & (0x01 << _bit))
#define BIT_0 1
#define BIT_1 2
#define BIT_2 4
#define BIT_3 8
#define BIT_4 16
#define BIT_5 32
#define BIT_6 64
#define BIT_7 128
#define and   &
#define ror   >>
#define rol   <<
#define BTFSC(_registr, _bit)  (_registr & _bit) != 0
#define BitSet(_registr, _bit)   (_registr |= (1<<_bit))		// definuje nastaven bitu
#define BitClear(_registr, _bit) (_registr &= ~(1<<_bit))       // definuje vynulovn bitu
#define BitNeg(_registr, _bit)   (_registr ^= (1<<_bit))		// definuje negovn bitu
#define _true  1
#define _false 0

//*****************************************************************************
#define AddressDS3231_read          0b11010001
#define AddressDS3231_write         0b11010000
#define AddressDS3231_temp_MSB      0x11
#define AddressDS3231_temp_LSB      0x12

/* I2C clock in Hz */
//#define SCL_CLOCK  1000000L
//#define SCL_CLOCK  1000L
#define _XTAL_FREQ 20000000  // 20 MHz OSC
#include <stdint.h> //uint8_t, uint16_t, uint32_t
//#define _wt_speed_i2c_Masterx  (((_XTAL_FREQ/SCL_CLOCK)-16)/2)  /* must be > 10 for stable operation */  //T72
#define _wt_speed_i2c_Masterx  1000L

#define ACKNOWLEDGE             1
#define NOT_ACKNOWLEDGE         0
#define MaskSeconds             0b00001111
#define MaskSeconds_10          0b01110000
#define MaskMinutes             0b00001111
#define MaskMinutes_10          0b01110000
#define MaskHour                0b00001111
#define MaskHour_10             0b00010000
#define MaskAM_PM               0b00100000
#define Mask_12_24              0b01000000
#define MaskClearSignTemp       0b01111111
#define MaskClear76bit          0b11111100
#define MaskClear76bitneg       0b00000011

#define SQW_RATE_1		0
#define SQW_RATE_1K		1
#define SQW_RATE_4K		2
#define SQW_RATE_8K		3
#define OUTPUT_SQW		0
#define OUTPUT_INT		1

#define and                     &
#define or                      |
#define tecka                   0x2e
#define minus                   0x2d
#define RST_RTC                 PORTB
#define _RB3                    3
#define INT_RTC                 RST_RTC
#define _RB4                    4
#define LATB_RTC                LATB
#define tRTC                    TRISB

struct {      
      uint8_t Seconds;          //:4
      uint8_t Seconds_10;       //:3;  
      uint8_t Minutes;          //:4;    
      uint8_t Minutes_10;       //:3;     
      uint8_t Hour;             //:4;    
      uint8_t Hour_10;          //:1; 
      uint8_t AM_PM;            //:1; 
      uint8_t _12_24;           //:1;
      uint8_t Day;              //1?7
      uint8_t Date;             //01?31  
      uint8_t Month_Century;    //01?12 + Century
      uint8_t Year;             //00?99
      uint8_t Alarm_1_Seconds;
      uint8_t Alarm_1_Minutes;
      uint8_t Alarm_1_Hours;    //1?12 + AM/PM  00?23
      uint8_t Alarm_1_Day_Date;
      uint8_t Alarm_2_Minutes;
      uint8_t Alarm_2_Hours;
      uint8_t Alarm_2_Day_Date;
      uint8_t Control;
      uint8_t Control_Status;   //Control/Status
      uint8_t Aging_Offset;     //Aging Offset
      uint8_t MSB_buffer_temp;  //:MSB of Temp
      uint8_t LSB_buffer_temp;  //:LSB of Temp
    }_DateTimeDS3231;
    
void ReadRTC (void);
void ParseSecond (uint8_t ParseData);
void ParseMinutes (uint8_t ParseData);
void ParseHour(uint8_t ParseData);
void init_RST_RTC (void);
void init_RTC (void);
void init_INT_RTC (void);
void ResetRTC (void);
void SetTime (void);
void SetDate (void);
float GetTemp(void);
char* _ftoa(float f);
void ShowTemp(void);
uint8_t CodeSeconds (uint8_t Seconds_10,uint8_t  Seconds);
uint8_t CodeMinutes (uint8_t Minutes_10,uint8_t Minutes);
uint8_t CodeHours (uint8_t Hour_10,uint8_t Hour);
uint8_t CodeDay (uint8_t Day);
uint8_t CodeDate (uint8_t Date);
uint8_t CodeMonth_Century (uint8_t Month_Century);
uint8_t CodeYear (uint8_t _Year);


#endif